#ifndef CASHBOXBUILDCONFIG_H
#define CASHBOXBUILDCONFIG_H

#include <QDir>
#include <QStandardPaths>
#include <QDate>
#include <QFileInfo>

#define CASHBOX_DATA_PATH QDir::fromNativeSeparators(QStringLiteral("%1/mkassa/").arg(QStandardPaths::writableLocation(QStandardPaths::GenericDataLocation)))
#define CASHBOX_BUILD_DT QLocale("en").toDateTime(QString("%1 %2").arg(__DATE__, __TIME__).simplified(), "MMM d yyyy hh:mm:ss")

inline QString getSdcardStoragePath() {
    QDir dir("/storage");
    QFileInfoList fil = dir.entryInfoList(QDir::Dirs);
    for(const QFileInfo &fi :fil)
    {
        //        lmWarning() << fi.fileName();
        if(fi.fileName().contains("-")) return fi.absoluteFilePath() + "/";
    }
    return "/storage/";
}


#define SDCARD_PATH getSdcardStoragePath()

#ifdef CASHBOX_SERVICE
#   define APPNAME "cashboxservice"
#   define ORGANISATION_NAME "Armax"
#   define ORGANISATION_DOMAIN "armax.ru"
#elif defined COREAPI_LIB
#elif defined CASHBOX_UI
#   define APPNAME "cashboxui"
#   define ORGANISATION_NAME "Armax"
#   define ORGANISATION_DOMAIN "armax.ru"
#elif defined CASHBOX_HTTP_SERVICE
#   define APPNAME "cashboxhttpservice"
#   define ORGANISATION_NAME "Armax"
#   define ORGANISATION_DOMAIN "armax.ru"
#endif



#define MAIN_QML "qrc:/main.qml"

#define SERVICE_CLASS "ru.armax.cashbox.CashboxService"
#define CASHBOX_SERVICE_PACKAGE_NAME "ru.armax.cashbox.mkassa"

#define DEFAULT_AMOUNT_MULT                 100u
#define DEFAULT_QUANTITY_MULT               1000u
#define DEFAULT_AMOUNT_DEC                 2u
#define DEFAULT_QUANTITY_DEC               3u

#define DEFAULT_SERIAL_LENGTH 12


#define UMKASERVER_HOST_URL "umka365.ru"
#define UMKASERVER_PORT	443
#define UMKASERVER_SCHEME "HTTPS"

#define CASHBOX_MODEL                   2005
#define CASHBOX_MODEL_NAME              "МКасса-Ф"
#define CASHBOX_SRV_MODEL               70
#define CASHBOX_VERSION                {QLatin1Char('0'),QLatin1Char('1'),QLatin1Char('2')}


//inline bool isDebugVersion() {
//    return QDate::currentDate() > QDate(2022, 03, 01);
//}

#define DEBUG_BUILD_VERSION                  0

//BUILTING MENU
#define ENABLE_SELF_APK_UPDATE_MENU                 1

//FULL CLEARING
#define FULL_CLEAR_AUTH_DEALER_ID  2

#define DISALE_FULL_CLEANING

#endif //CASHBOXBUILDCONFIG_H
