#ifndef HWMODELDATASTORAGE_H
#define HWMODELDATASTORAGE_H

#include "modeldata.h"
#include <QAndroidJniObject>
#include <QMutex>


#define ALLOW_HW_MODEL_DATA_STORAGE 1
#define ALLOW_OLD_MODEL_DATA_READ   1

#if ALLOW_HW_MODEL_DATA_STORAGE

class HwModelDataStorage
{
    Q_DISABLE_COPY(HwModelDataStorage)
    static const quint32 MAG = 0xAABBCCDDu;
    friend class OldDataReader;
public:
    HwModelDataStorage();
    ~HwModelDataStorage();

    ModelData getModelData();
    void setModelData(const ModelData &md);

    void cleanAll() const;

private:
    bool readNvRam(quint16 addr, quint16 count, QByteArray &buf);
};

#endif

//TODO: Возможно сделать восстановление серверной модели по модели кассы по списку соответствия


#endif // HWMODELDATASTORAGE_H
