QT -= gui
QT += androidextras network sql gui

TEMPLATE = lib
DEFINES += CASHBOXAPI_LIBRARY CASHBOXAPI_LIB
CONFIG += create_prl c++17

!contains(DEFINES, QT_MESSAGELOGCONTEXT) {
    DEFINES += QT_MESSAGELOGCONTEXT
}
contains(DEFINES, QT_NO_MESSAGELOGCONTEXT) {
    DEFINES -= QT_MESSAGELOGCONTEXT
}


CONFIG += c++17
QMAKE_CXXFLAGS += -std=c++17
# You can make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

include($$(CASHBOX_CONF))
include(src/osdabzip/osdabzip.pri)

INCLUDEPATH += src src/utils src/print src/print/bbcode src/data src/fs src/ffd src/docs

SOURCES += \
    src/cashboxapilib.cpp \
    src/cashboxserviceapi.cpp \
    src/cfg/apiconfig.cpp \
    src/cfg/basecoreconfigdata.cpp \
    src/cfg/baseiniconfigstore.cpp \
    src/cfg/iserviceconfigdata.cpp \
    src/cfg/receiptconfigdata.cpp \
    src/data/cashboxstatus.cpp \
    src/data/cashier.cpp \
    src/data/coreapiconst.cpp \
    src/data/coreapiresult.cpp \
    src/data/coretransaction.cpp \
    src/data/devicestatus.cpp \
    src/data/fdfconstants.cpp \
    src/data/incomingreg.cpp \
    src/data/inn.cpp \
    src/data/labelcheckdata.cpp \
    src/data/labelcheckresult.cpp \
    src/data/modeldata.cpp \
    src/data/ofdsettings.cpp \
    src/data/receipt.cpp \
    src/data/receiptoperation.cpp \
    src/data/regdata.cpp \
    src/data/registrationflags1290.cpp \
    src/data/regnumber.cpp \
    src/data/regreasons.cpp \
    src/data/receiptdataclasses.cpp \
    src/data/simplereceiptoperation.cpp \
    src/data/tax.cpp \
    src/data/umka365SessionData.cpp \
    src/docs/basedoc.cpp \
    src/docs/calcreportdoc.cpp \
    src/docs/cycleclosedoc.cpp \
    src/docs/cycleopendoc.cpp \
    src/docs/fsclosedoc.cpp \
    src/docs/receiptdoc.cpp \
    src/docs/regdoc.cpp \
    src/docs/xreport.cpp \
    src/ffd/basedatavalidator.cpp \
    src/ffd/regdatavalidator.cpp \
    src/fs/fscounters.cpp \
    src/fs/fsfullstatus.cpp \
    src/fs/tlv.cpp \
    src/print/bbcode/BBDocument.cpp \
    src/print/bbcode/bbcodeparser.cpp \
    src/print/bbcode/bbcpputils.cpp \
    src/print/monochromeimage.cpp \
    src/print/printdocumentformatter.cpp \
    src/print/textprinterdocument.cpp \
    src/utils/abstractworker.cpp \
    src/utils/abstractworkercontroller.cpp \
    src/utils/abstractworkerthread.cpp \
    src/utils/androidapihelper.cpp \
    src/utils/appdirectories.cpp \
    src/utils/basesqlitedbconnector.cpp \
    src/utils/des.c \
    src/utils/dircreator.cpp \
    src/utils/fixnumber.cpp \
    src/utils/formatutils.cpp \
    src/utils/labelcode.cpp \
    src/utils/localizationmgr.cpp \
    src/utils/loggermanager.cpp \
    src/utils/logmanip.cpp \
    src/utils/productcodecreator.cpp \
    src/utils/qextdes.cpp

HEADERS += \
    src/cashboxapilib.h \
    src/cashboxapilib_global.h \
    src/cashboxserviceapi.h \
    src/cfg/apiconfig.h \
    src/cfg/basecoreconfigdata.h \
    src/cfg/baseiniconfigstore.h \
    src/cfg/iserviceconfigdata.h \
    src/cfg/receiptconfigdata.h \
    src/data/cashboxstatus.h \
    src/data/cashier.h \
    src/data/coreapiconst.h \
    src/data/coreapiresult.h \
    src/data/coretransaction.h \
    src/data/devicestatus.h \
    src/data/fdfconstants.h \
    src/data/incomingreg.h \
    src/data/inn.h \
    src/data/labelcheckdata.h \
    src/data/labelcheckresult.h \
    src/data/modeldata.h \
    src/data/ofdsettings.h \
    src/data/receipt.h \
    src/data/receiptoperation.h \
    src/data/regdata.h \
    src/data/registrationflags1290.h \
    src/data/regnumber.h \
    src/data/regreasons.h \
    src/data/receiptdataclasses.h \
    src/data/simplereceiptoperation.h \
    src/data/tax.h \
    src/data/umka365SessionData.h \
    src/docs/basedoc.h \
    src/docs/calcreportdoc.h \
    src/docs/cycleclosedoc.h \
    src/docs/cycleopendoc.h \
    src/docs/fsclosedoc.h \
    src/docs/receiptdoc.h \
    src/docs/regdoc.h \
    src/docs/xreport.h \
    src/ffd/basedatavalidator.h \
    src/ffd/regdatavalidator.h \
    src/fs/fscounters.h \
    src/fs/fsfullstatus.h \
    src/fs/tlv.h \
    src/print/bbcode/BBDocument.h \
    src/print/bbcode/bbcodeparser.h \
    src/print/bbcode/bbcpputils.h \
    src/print/monochromeimage.h \
    src/print/printdocumentformatter.h \
    src/print/textprinterdocument.h \
    src/utils/abstractworker.h \
    src/utils/abstractworkercontroller.h \
    src/utils/abstractworkerthread.h \
    src/utils/androidapihelper.h \
    src/utils/appdirectories.h \
    src/utils/basesqlitedbconnector.h \
    src/utils/crc.h \
    src/utils/des.h \
    src/utils/dircreator.h \
    src/utils/fixnumber.h \
    src/utils/formatutils.h \
    src/utils/labelcode.h \
    src/utils/localizationmgr.h \
    src/utils/logconsts.h \
    src/utils/loggermanager.h \
    src/utils/logmanip.h \
    src/utils/productcodecreator.h \
    src/utils/qextdes.h

!isEmpty(target.path): INSTALLS += target



CONFIG(debug, debug|release) {
    TARGET=$$qtLibraryTarget(cashboxapilib)
    DESTDIR = $(BUILDPATH)/lib/debug
}
CONFIG(release, debug|release) {
    TARGET=$$qtLibraryTarget(cashboxapilib)
    DESTDIR = $(BUILDPATH)/lib/release
}
