#include "ofdsettings.h"


const QMap<QString, OfdSettings> OfdSettings::SUPPORTED_OFD = {
    std::make_pair(QStringLiteral("7704211201"), OfdSettings(
    QStringLiteral("7704211201"),
    "f1.taxcom.ru", 7777, "8.8.8.8", 10000, "http://receipt.taxcom.ru/",
    QStringLiteral("Общество с ограниченной ответственностью Такском"),
    QStringLiteral("Такском"))),

    std::make_pair(QStringLiteral("9715260691"), OfdSettings(
    QStringLiteral("9715260691"),
    "ofdp.platformaofd.ru", 21101, "8.8.8.8",
    10000, "https://lk.platformaofd.ru/web/noauth/cheque/search/",
    QStringLiteral("Общество с ограниченной ответственностью Эвотор ОФД"),
    QStringLiteral("Эвотор ОФД"))),

    std::make_pair(QStringLiteral("7709364346"), OfdSettings(
    QStringLiteral("7709364346"),
    "k-server.1-ofd.ru", 7777, "8.8.8.8", 10000, "http://consumer.1-ofd.ru/",
    QStringLiteral("Акционерное общество Энергетические системы и коммуникации"),
    QStringLiteral("Энергетические системы и коммуникации"))),

    std::make_pair(QStringLiteral("7728699517"), OfdSettings(
    QStringLiteral("7728699517"),
    "connect.ofd-ya.ru", 7779, "8.8.8.8", 10000, "https://ofd-ya.ru/open_service/",
    QStringLiteral("Общество с ограниченной ответственностью Ярус"),
    QStringLiteral("Ярус"))),

    std::make_pair(QStringLiteral("7841465198"), OfdSettings(
    QStringLiteral("7841465198"),
    "gate.ofd.ru", 4000, "8.8.8.8", 10000, "http://ofd.ru/checkinfo/",
    QStringLiteral("Общество с ограниченной ответственностью ПЕТЕР-СЕРВИС Спецтехнологии"),
    QStringLiteral("ПЕТЕР-СЕРВИС Спецтехнологии"))),

    std::make_pair(QStringLiteral("7605016030"), OfdSettings(
    QStringLiteral("7605016030"),
    "kkt.sbis.ru", 7777, "8.8.8.8", 10000, "https://ofd.sbis.ru/",
    QStringLiteral("Общества с ограниченной ответственностью Компания Тензор"),
    QStringLiteral("Компания Тензор"))),

    std::make_pair(QStringLiteral("4029017981"), OfdSettings(
    QStringLiteral("4029017981"),
    "ofd.astralnalog.ru", 7777, "8.8.8.8", 10000, "https://ofd.astralnalog.ru/#find-ticket/",
    QStringLiteral("Закрытое акционерное общество КАЛУГА АСТРАЛ"),
    QStringLiteral("КАЛУГА АСТРАЛ"))),

    std::make_pair(QStringLiteral("6663003127"), OfdSettings(
    QStringLiteral("6663003127"),
    "ofd.kontur.ru", 7777, "8.8.8.8", 10000, "https://cash.kontur.ru/CashReceipt/Search/",
    QStringLiteral("Закрытое акционерное общество Производственная фирма СКБ Контур"),
    QStringLiteral("СКБ Контур"))),


    std::make_pair(QStringLiteral("7704358518"), OfdSettings(
    QStringLiteral("7704358518"),
    "kkt.ofd.yandex.net", 12345, "8.8.8.8", 10000, "https://ofd.yandex.ru/",
    QStringLiteral("Общество с ограниченной ответственностью Яндекс.ОФД"),
    QStringLiteral("Яндекс.ОФД"))),

    std::make_pair(QStringLiteral("7729633131"), OfdSettings(
    QStringLiteral("7729633131"),
    "ofd.garantexpress.ru", 30801, "8.8.8.8", 10000, "http://www.garantexpress.ru/",
    QStringLiteral("Общество с ограниченной ответственностью Электронный экспресс"),
    QStringLiteral("Электронный экспресс"))),

    std::make_pair(QStringLiteral("7801392271"), OfdSettings(
    QStringLiteral("7801392271"),
    "92.38.2.202", 7001, "8.8.8.8", 10000, "https://www.esphere.ru/",
    QStringLiteral("Общества с ограниченной ответственностью КОРУС Консалтинг СНГ"),
    QStringLiteral("КОРУС Консалтинг СНГ"))),

    std::make_pair(QStringLiteral("2310031475"), OfdSettings(
    QStringLiteral("2310031475"),
    "kkt.ofd-magnit.ru", 7001, "8.8.8.8", 10000, "https://check.ofd-magnit.ru/CheckWebApp/fiscaldocsearch.zul/",
    QStringLiteral("Акционерное общество Тандер"),QStringLiteral("Тандер"))),//АО ТАНДЕР - не правильные данные

    std::make_pair(QStringLiteral("5902034504"), OfdSettings(
    QStringLiteral("5902034504"),
    "kkt.ofd-initpro.ru", 9999, "8.8.8.8", 10000, "https://ofd-initpro.ru/check-bill/",
    QStringLiteral("Общество с ограниченной ответственностью Удостоверяющий центр \"ИнитПро\""),
    QStringLiteral("Удостоверяющий центр \"ИнитПро\""))),//Общество с ограниченной ответственностью Удостоверяющий центр «ИнитПро»

    std::make_pair(QStringLiteral("7729642175"), OfdSettings(
    QStringLiteral("7729642175"),
    "kkt.e-ofd.ru", 7777, "8.8.8.8", 10000, "https://e-ofd.ru/check/",
    QStringLiteral("Общество с ограниченной ответственностью \"ГРУППА ЭЛЕМЕНТ\""),
    QStringLiteral("ГРУППА ЭЛЕМЕНТ"))),//Общество с ограниченной ответственностью «ГРУППА ЭЛЕМЕНТ»


    std::make_pair(QStringLiteral("7703282175"), OfdSettings(
    QStringLiteral("7703282175"),
    "127.0.0.1", 7777, "8.8.8.8", 10000, "http://ofd.nvg.ru/receipt/",
    QStringLiteral("Акционерное общество \"Энвижн Груп\""), QStringLiteral("Энвижн Груп"))),//Акционерное общество «Энвижн Груп»

    std::make_pair(QStringLiteral("7713076301"), OfdSettings(
    QStringLiteral("7713076301"),
    "217.118.87.210", 7765, "8.8.8.8", 10000, "http://ofd.beeline.ru:81/check-order/",
    QStringLiteral("Публичное акционерное общество \"Вымпел-Коммуникации\""),
    QStringLiteral("Вымпел-Коммуникации"))),//Публичное акционерное общество «Вымпел-Коммуникации»

    std::make_pair(QStringLiteral("7710007966"), OfdSettings(
    QStringLiteral("7710007966"),
    "ofd.multicarta.ru", 21101, "8.8.8.8", 10000, "https://ofdcheck.multicarta.ru/",
    QStringLiteral("Общество с ограниченной ответственностью \"МультиКарта\""),
    QStringLiteral("МультиКарта"))),//Общество с ограниченной ответственностью «МультиКарта»

    std::make_pair(QStringLiteral("7802870820"), OfdSettings(
    QStringLiteral("7802870820"),
    "185.241.176.4", 21101, "8.8.8.8", 10000, "https://ofdcheck.multicarta.ru/",
    QStringLiteral("Общество с ограниченной ответственностью \"Дримкас\""),
    QStringLiteral("Дримкас"))),//Общество с ограниченной ответственностью «Дримкас»

    std::make_pair(QStringLiteral("6658497833"), OfdSettings(
    QStringLiteral("6658497833"),
    "ofd.kontur.ru", 7777, "8.8.8.8", 10000, "cash-ntt.kontur.ru",
    QStringLiteral("Общество с ограниченной ответственностью \"Контур НТТ\""),
    QStringLiteral("Контур НТТ"))),//Общество с ограниченной ответственностью «Контур НТТ»

    std::make_pair(QStringLiteral("7714731464"), OfdSettings(
    QStringLiteral("7714731464"),
    "109.73.43.4", 19086, "8.8.8.8", 10000, "109.73.43.4:63188",
    QStringLiteral("Тестовый ОФД Атлас кард"),
    QStringLiteral("Атлас (ТЕСТ)"),
    QStringLiteral("82.202.183.18"), 21701, QStringLiteral("31.44.83.188"), 31101)),

};


OfdSettings::OfdSettings(const QString &inn, const QString &address, quint16 port,
                         const QString &dns, quint16 queryInterval, const QString &url,
                         const QString &name, const QString &shortName) noexcept
    : inn_(inn)
    , address_(address.trimmed())
    , port_(port)
    , dns_(dns.trimmed())
    , queryInterval_(queryInterval)
    , url_(url)
    , name_(name)
    , shortName_(shortName)
    , labelsAddress_()
    , labelsPort_(0)
    , keysAddress_()
    , keysPort_(0)
    , testTimeout_(3000)
    , keysTimeout_(30000)

{

}

OfdSettings::OfdSettings(const QString &inn, const QString &address, quint16 port, const QString &dns,
                         quint16 queryInterval, const QString &url, const QString &name,
                         const QString &shortName, const QString &labelsAddress, quint16 labelsPort,
                         const QString &keysAddress, quint16 keysPort) noexcept
    : inn_(inn)
    , address_(address.trimmed())
    , port_(port)
    , dns_(dns.trimmed())
    , queryInterval_(queryInterval)
    , url_(url)
    , name_(name)
    , shortName_(shortName)
    , labelsAddress_(labelsAddress)
    , labelsPort_(labelsPort)
    , keysAddress_(keysAddress)
    , keysPort_(keysPort)
    , testTimeout_(3000)
    , keysTimeout_(30000)

{

}

OfdSettings::OfdSettings() noexcept
    : inn_()
    , address_(QString(64, QLatin1Char(' ')))
    , port_(0)
    , dns_()
    , queryInterval_(10000)
    , url_(QStringLiteral("http://URL/par"))
    , name_()
    , shortName_()
    , labelsAddress_()
    , labelsPort_(0)
    , keysAddress_()
    , keysPort_(0)
    , testTimeout_(3000)
    , keysTimeout_(30000)



{

}

OfdSettings::OfdSettings(const OfdSettings &other) noexcept
    : inn_(other.inn_)
    , address_(other.address_)
    , port_(other.port_)
    , dns_(other.dns_)
    , queryInterval_(other.queryInterval_)
    , url_(other.url_)
    , name_(other.name_)
    , shortName_(other.shortName_)
    , labelsAddress_(other.labelsAddress_)
    , labelsPort_(other.labelsPort_)
    , keysAddress_(other.keysAddress_)
    , keysPort_(other.keysPort_)
    , testTimeout_(other.testTimeout_)
    , keysTimeout_(other.keysTimeout_)


{

}

OfdSettings::OfdSettings(OfdSettings &&other) noexcept
    : inn_()
    , address_()
    , port_(other.port_)
    , dns_()
    , queryInterval_(other.queryInterval_)
    , url_()
    , name_()
    , shortName_()
    , labelsAddress_()
    , labelsPort_(other.labelsPort_)
    , keysAddress_()
    , keysPort_(other.keysPort_)
    , testTimeout_(other.testTimeout_)
    , keysTimeout_(other.keysTimeout_)


{
    inn_.swap(other.inn_);
    address_.swap(other.address_);
    dns_.swap(other.dns_);
    url_.swap(other.url_);
    name_.swap(other.name_);
    shortName_.swap(other.shortName_);
    labelsAddress_.swap(other.labelsAddress_);
    keysAddress_.swap(other.keysAddress_);
}

OfdSettings::OfdSettings(const QVariantMap &other) noexcept
    : inn_()
    , address_()
    , port_()
    , dns_()
    , queryInterval_()
    , url_()
    , name_()
    , shortName_()
    , labelsAddress_()
    , labelsPort_(0)
    , keysAddress_()
    , keysPort_(0)

{
    setMap(other);
}

OfdSettings::~OfdSettings()
{

}

bool OfdSettings::isValid() const
{
    return !address_.isEmpty() && port_ > 0;
}

QString OfdSettings::address() const
{
    return address_.trimmed();
}

void OfdSettings::setAddress(const QString &address)
{
    address_ = address.trimmed();
}

quint16 OfdSettings::port() const
{
    return port_;
}

void OfdSettings::setPort(const quint16 &port)
{
    port_ = port;
}

QString OfdSettings::dns() const
{
    return dns_.trimmed();
}

void OfdSettings::setDns(const QString &dns)
{
    dns_ = dns.trimmed();
}


quint32 OfdSettings::queryInterval() const
{
    return queryInterval_;
}

void OfdSettings::setQueryInterval(const quint32 &queryInterval)
{
    queryInterval_ = queryInterval;
}

QString OfdSettings::url() const
{
    return url_.trimmed();
}

void OfdSettings::setUrl(const QString &url)
{
    url_ = url.trimmed();
}
QString OfdSettings::name() const
{
    return name_;
}

void OfdSettings::setName(const QString &name)
{
    name_ = name;
}

QString OfdSettings::inn() const
{
    return inn_;
}

void OfdSettings::setInn(const QString &inn)
{
    inn_ = inn.trimmed();
}


QString OfdSettings::shortName() const
{
    return shortName_.isEmpty() ? name_ : shortName_;
}

void OfdSettings::setShortName(const QString &shortName)
{
    shortName_ = shortName;
}

const QString &OfdSettings::labelsAddress() const
{
    return labelsAddress_;
}

void OfdSettings::setLabelsAddress(const QString &newLabelsAddress)
{
    labelsAddress_ = newLabelsAddress;
}

quint16 OfdSettings::labelsPort() const
{
    return labelsPort_;
}

void OfdSettings::setLabelsPort(quint16 newLabelsPort)
{
    labelsPort_ = newLabelsPort;
}

const QString &OfdSettings::keysAddress() const
{
    return keysAddress_;
}

void OfdSettings::setKeysAddress(const QString &newKeysAddress)
{
    keysAddress_ = newKeysAddress;
}

quint16 OfdSettings::keysPort() const
{
    return keysPort_;
}

void OfdSettings::setKeysPort(quint16 newKeysPort)
{
    keysPort_ = newKeysPort;
}


qint32 OfdSettings::testTimeout() const
{
    return testTimeout_> 1000 ?
                testTimeout_ : 3000;
}

void OfdSettings::setTestTimeout(qint32 newTestTimeout)
{
    testTimeout_ = newTestTimeout;
}

qint32 OfdSettings::keysTimeout() const
{
    return keysTimeout_ > 1000 ? keysTimeout_ : 30000;
}

void OfdSettings::setKeysTimeout(qint32 newKeysTimeout)
{
    keysTimeout_ = newKeysTimeout;
}



QVariantMap OfdSettings::toMap() const
{
    QVariantMap res;
    res.insert("inn", inn_.trimmed());
    res.insert("addr", address_);
    res.insert("port", port_);
//    res.insert("dns", dns_);
    res.insert("interval", queryInterval_);
    res.insert("url", url_);
    res.insert("name", name_);
    res.insert("sname", shortName_);
    res.insert("labelsAddr", labelsAddress_);
    res.insert("labelsPort", labelsPort_);
    res.insert("keysAddr", keysAddress_);
    res.insert("keysPort", keysPort_);
    res.insert("testTout", testTimeout_);
    res.insert("keysTout", keysTimeout_);

    return res;
}

void OfdSettings::setMap(const QVariantMap &map)
{
    inn_ = map["inn"].toString().trimmed();
    address_ = map["addr"].toString();
    port_ = map["port"].toUInt();
//    dns_ = map["dns"].toString();
    queryInterval_ = map["interval"].toInt();
    url_ = map["url"].toString();
    name_ = map["name"].toString();
    shortName_ = map["sname"].toString();
    labelsAddress_ = map["labelsAddr"].toString().trimmed();
    labelsPort_ = map["labelsPort"].toUInt();
    keysAddress_ = map["keysAddr"].toString();
    keysPort_ = map["keysPort"].toUInt();
    testTimeout_ = map["testTout"].toInt();
    keysTimeout_ = map["keysTout"].toInt();
}

OfdSettings &OfdSettings::operator=(const OfdSettings &other) noexcept
{
    inn_ = other.inn_;
    address_ = other.address_;
    port_ = other.port_;
    dns_ = other.dns_;
    queryInterval_ = other.queryInterval_;
    url_ = other.url_;
    name_ = other.name_;
    shortName_ = other.shortName_;
    labelsAddress_ = other.labelsAddress_;
    labelsPort_ = other.labelsPort_;
    keysAddress_ = other.keysAddress_;
    keysPort_ = other.keysPort_;
    testTimeout_ = other.testTimeout_;
    keysTimeout_ = other.keysTimeout_;
    return *this;
}

OfdSettings &OfdSettings::operator=(OfdSettings &&other)noexcept
{
    inn_.swap(other.inn_);
    address_.swap(other.address_);
    port_ = other.port_;
    dns_.swap(other.dns_);
    queryInterval_ = other.queryInterval_;
    url_.swap(other.url_);
    name_.swap(other.name_);
    shortName_.swap(other.shortName_);
    labelsAddress_.swap(other.labelsAddress_);
    labelsPort_ = other.labelsPort_;
    keysAddress_.swap(other.keysAddress_);
    keysPort_ = other.keysPort_;
    testTimeout_ = other.testTimeout_;
    keysTimeout_ = other.keysTimeout_;

    return *this;

}

bool OfdSettings::operator==(const OfdSettings &other) const
{
    return	inn_ == other.inn_ &&
            address_ == other.address_ &&
            port_ == other.port_ &&
            dns_ == other.dns_ &&
            queryInterval_ == other.queryInterval_ &&
            url_ == other.url_ &&
            name_ == other.name_ &&
            shortName_ == other.shortName_ &&
            labelsAddress_ == other.labelsAddress_ &&
            labelsPort_ == other.labelsPort_ &&
            keysAddress_ == other.keysAddress_ &&
            keysPort_ == other.keysPort_ &&
            testTimeout_ == other.testTimeout_ &&
            keysTimeout_ == other.keysTimeout_;




}

bool OfdSettings::operator!=(const OfdSettings &other) const
{
    return !(*this == other);
}
