#ifndef XREPORT_H
#define XREPORT_H

#include "fdfconstants.h"
#include "regdata.h"
#include "modeldata.h"
#include "fscounters.h"
#include "fsfullstatus.h"

#include <QObject>

//TODO: Добавить отдельно адрес и пр. без рег. даты. для поддержки пост запросов

class XReport : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(XReport)
public:
    explicit XReport(QObject *parent = nullptr);
    explicit XReport(const FsCounters &counters, QObject *parent = nullptr);
    explicit XReport(const fdf::DocType &type, QObject *parent = nullptr);
    ~XReport() override;

    QString docName() const;
    QString docShortName() const;


    fdf::DocType type() const;

    const QDateTime &dt() const;
    void setDt(const QDateTime &newDt);

    const ModelData &model() const;
    void setModel(const ModelData &newModel);

    const RegData &regData() const;
    void setRegData(const RegData &newRegData);

    const QString &externalId() const;
    void setExternalId(const QString &newExternalId);

    const QString &clientId() const;
    void setClientId(const QString &newClientId);

    const QString &header() const;
    void setHeader(const QString &newHeader);

    const QString &footer() const;
    void setFooter(const QString &newFooter);

    const FsCounters &counters() const;
    void setCounters(const FsCounters &newCounters);

    const FsFullStatus &status() const;
    void setStatus(const FsFullStatus &newStatus);

    const QString &cashier() const;
    void setCashier(const QString &newCashier);

    const QString &cashierInn() const;
    void setCashierInn(const QString &newCashierInn);

    const QString &address() const;
    void setAddress(const QString &newAddress);

    const QString &place() const;
    void setPlace(const QString &newPlace);


    void clean();
    QVariantMap toMap() const;
    QVariantMap toExternalMap() const;
    QString toHtml() const;
    void parseMap(const QVariantMap &map);


private:
    fdf::DocType type_;
    QDateTime dt_;
    //NOTE: если будут требовать адрес и место расчетов - надо будет делать как в документах
    ModelData model_;
    RegData regData_;
    QString externalId_;
    QString clientId_;
    QString header_;
    QString footer_;
    FsCounters counters_;
    FsFullStatus status_;
    QString cashier_;
    QString cashierInn_;
    QString address_;
    QString place_;
};

#endif // XREPORT_H
