#ifndef MONOCHROMEIMAGE_H
#define MONOCHROMEIMAGE_H

#include <QByteArray>
#include <QtGlobal>
#include <QVariant>

class MonochromeImage
{
public:
    MonochromeImage()noexcept;
    explicit MonochromeImage(const QVariantMap &data)noexcept;
    MonochromeImage(const MonochromeImage &other)noexcept;
    MonochromeImage(MonochromeImage &&other)noexcept;
    ~MonochromeImage();

    bool isValid() const;
    int width() const;
    void setWidth(int w);
    int height() const;
    void setHeight(int h);
    QByteArray image() const;
    void setImage(const QByteArray &im);
    QString fileName() const;
    void setFileName(const QString &fileName);


    bool pixel(qint32 x, qint32 y, qint32 rawword = 32) const;
    bool setPixel(qint32 x, qint32 y, bool black, qint32 rawword = 32);

    QByteArray raw(int y, qint32 rawword = 32) const;

    QVariantMap toMap() const;
    void setMap(const QVariantMap &data);

    MonochromeImage &operator = (const MonochromeImage &other)noexcept;
    MonochromeImage &operator = (MonochromeImage &&other) noexcept;
    bool operator == (const MonochromeImage &other) const noexcept;
    bool operator != (const MonochromeImage &other) const noexcept;

    static MonochromeImage createEmpty(qint32 w, qint32 h, qint32 rawword);


private:
    int width_;
    int height_;
    QByteArray images_;
    QString fileName_;
};


#endif // MONOCHROMEIMAGE_H
