#ifndef ANDROIDAPIHELPER_H
#define ANDROIDAPIHELPER_H

#include "fixnumber.h"

#include <QObject>
#include <QMutex>

class QAndroidJniObject;

class AndroidApiHelper : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(AndroidApiHelper)
public:
    explicit AndroidApiHelper(QObject *parent = nullptr)noexcept;
    virtual ~AndroidApiHelper() override;

    void showDateTimeSettings();

    //--------------------------------Серийники-----------------------------------------------------
    /**
     * @brief getDsn
     * @return дсн из java апи
     * На данный все 3 метода возвращают одно и то же. надо сделать апи в другом месте на случай, если
     * нет дсн и серийник брать из другого места.
     */
    QString getDsn();
    QString getHardwareHash();
    QString getSerial();
    //--------------------------------Серийники-----------------------------------------------------

    QString packageName() const;
    QString packagePath() const;
    QString versionName() const;
    qint64 versionCode() const;

    bool installPackage(const QString &path) const;
    bool uninstallPackage(const QString &packageName) const;

    QString sdcardStorage() const;

    QString filePackageName(const QString &path) const;
    QString fileVersionName(const QString &path) const;
    qint64 fileVersionCode(const QString &path) const;

    QString currentNetworkInterfaceName() const;


    FixNumber getAccumLevel() const;

    void showPackageActivity(const QString &pckg);
    void initApp();
    void releaseApp();
    QString getImei(qint32 slot);
    QString parseBarcode(const QByteArray &imageBytes);

    void showDateTimeConfig();
    void showWifiConfig();
    void showGsmConfig();
    void showMobileDataConfig();
    void initForeGround();
    bool sendAboutToLouncher(const QString &serial, const QString &modelName, int modelCode) const;
    void sendBroadCast(const QString &action, const QString &key, const QVariant &data);
    bool isPackageIstalled(const QString &pkg) const;
    bool cashbox105Installed()const;
signals:
private:
    QAndroidJniObject *obj_;
    static QMutex _cashDataMutex;

};

#endif // ANDROIDAPIHELPER_H
