#include "appdirectories.h"

#include "cashboxbuildconfig.h"
#include "logmanip.h"
#include <dircreator.h>

AppDirectories::AppDirectories() noexcept
    : workDir_(CASHBOX_DATA_PATH)
{
//    lmWarning() << "S";
    DirCreator::checkAndCreate(workDir_);
    DirCreator::checkAndCreate(logsPath());
    DirCreator::checkAndCreate(translations());
    DirCreator::checkAndCreate(modelDataDir());
    DirCreator::checkAndCreate(offlineNotifications());
    DirCreator::checkAndCreate(watcherDir());
    DirCreator::checkAndCreate(configDir());
    DirCreator::checkAndCreate(imagesPath());
    DirCreator::checkAndCreate(dbDir());
    DirCreator::checkAndCreate(dbErrorsDir());
    DirCreator::checkAndCreate(tmpPath());
    DirCreator::checkAndCreate(tmpLogsPath());
//    lmWarning() << "F";
}

AppDirectories::~AppDirectories()
{

}

QString AppDirectories::logsPath() const
{
    return workDir_ + "/logs";
}

QString AppDirectories::translations() const
{
    return /*workDir_ +*/ ":/translations";
}

QString AppDirectories::workDir() const
{
    return workDir_;
}

QString AppDirectories::configDir() const
{
    return workDir_ + "/cfg";
}

QString AppDirectories::watcherDir() const
{
    return workDir_ + "/watcher";
}

QString AppDirectories::modelDataDir() const
{
    return workDir_ + "/model";
}

QString AppDirectories::dbDir() const
{
    return workDir_ + "/db";
}

QString AppDirectories::dbErrorsDir() const
{
    return  dbDir() + "/errors";
}


QString AppDirectories::logo() const
{
    return workDir_ + "/logo.png";
}

QString AppDirectories::offlineNotifications() const
{
    return workDir_ + "/offline";
}

QString AppDirectories::imagesPath() const
{
    return workDir_ + "/images";
}

QString AppDirectories::tmpPath() const
{
    return workDir_ + "/tmp";
}

QString AppDirectories::tmpLogsPath() const
{
    return workDir_ + "/tmp/logs";
}
