#ifndef CASHBOXHTTPSERVICEROOT_H
#define CASHBOXHTTPSERVICEROOT_H

#include <QtHttpServer>
#include <QObject>
#include <QPointer>
#include <QUdpSocket>
#include "httpcashboxserviceapi.h"

class CashboxHttpServiceRoot : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(CashboxHttpServiceRoot)
public:
    static int start(int &argc, char *argv[]);
    static CashboxHttpServiceRoot* instance() {return _instance;}
public slots:
    void setUpLocale(const QLocale &locale);
    void setUpLocale();

    void startHttp();
    void stopHttp();
    void startUdp();
    void stopUdp();

signals:

private:
    static CashboxHttpServiceRoot* _instance;
    int * argc_;
    char ** argv_;
    QHttpServer *server_;
    QUdpSocket *broadCastSocket_;
    ModelData lastModelData_;


    CashboxHttpServiceRoot(int &argc, char *argv[]);
    virtual ~CashboxHttpServiceRoot() override;

    void doSetupLocale(const QLocale &locale);
    bool createApplication();

    bool init();
    int exec();
    void stop();
private slots:
    void startAfterExec();
    void processPendingDatagramm();
    void sendBroadCast();
};

#define serviceRoot CashboxHttpServiceRoot::instance()

#endif // CASHBOXHTTPSERVICEROOT_H
