QT += androidextras network sql concurrent gui serialport
CONFIG += c++17 dll
CONFIG -= app_bundle

# You can make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

DEFINES += CASHBOX_SERVICE



INCLUDEPATH += src src/configdb src/processing src/wrappers src/db src/fs src/utils
!contains(DEFINES, QT_MESSAGELOGCONTEXT) {
    DEFINES += QT_MESSAGELOGCONTEXT
}
contains(DEFINES, QT_NO_MESSAGELOGCONTEXT) {
    DEFINES -= QT_MESSAGELOGCONTEXT
}

include($$(CASHBOXAPI_LIB)/cashboxapilib.pri)
include($$(CASHBOX_CONF))


# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target

HEADERS += \
    src/cashboxservicebinder.h \
    src/cashboxserviceroot.h \
    src/configdb/coreconfigdb.h \
    src/configdb/coreconfigstore.h \
    src/cryptedsettingsstorage.h \
    src/db/basedocdbsaver.h \
    src/db/docsdb.h \
    src/fs/fsarchivereportbase.h \
    src/fs/fsmsg.h \
    src/fs/ofdfscmd.h \
    src/fs/ofdmsgcontainer.h \
    src/modeldatastorage.h \
    src/processing/basetaskprocessor.h \
    src/processing/fiscalizationcontroller.h \
    src/processing/frworkingthread.h \
    src/processing/internalobjectsorage.h \
    src/processing/keysupdater.h \
    src/processing/labelschecker.h \
    src/processing/ofdworker.h \
    src/processing/oismworker.h \
    src/processing/processingdatawrapper.h \
    src/processing/processingqueue.h \
    src/processing/processingqueueprivate.h \
    src/processing/receiptscontroller.h \
    src/processing/reportscontroller.h \
    src/utils/printdocwatcher.h \
    src/utils/umkaauth.h \
    src/utils/watcherator.h \
    src/utils/watcherdb.h \
    src/wrappers/printerswrapper.h\
    src/wrappers/fswrapper.h\
    src/utils/syncsocketwrapper.h
SOURCES += \
    src/cashboxservicebinder.cpp \
    src/cashboxserviceroot.cpp \
    src/configdb/coreconfigdb.cpp \
    src/configdb/coreconfigstore.cpp \
    src/cryptedsettingsstorage.cpp \
    src/db/basedocdbsaver.cpp \
    src/db/docsdb.cpp \
    src/fs/fsarchivereportbase.cpp \
    src/fs/fsmsg.cpp \
    src/fs/ofdfscmd.cpp \
    src/fs/ofdmsgcontainer.cpp \
    src/main.cpp \
    src/modeldatastorage.cpp \
    src/processing/basetaskprocessor.cpp \
    src/processing/fiscalizationcontroller.cpp \
    src/processing/frworkingthread.cpp \
    src/processing/internalobjectsorage.cpp \
    src/processing/keysupdater.cpp \
    src/processing/labelschecker.cpp \
    src/processing/ofdworker.cpp \
    src/processing/oismworker.cpp \
    src/processing/processingdatawrapper.cpp \
    src/processing/processingqueue.cpp \
    src/processing/processingqueueprivate.cpp \
    src/processing/receiptscontroller.cpp \
    src/processing/reportscontroller.cpp \
    src/utils/printdocwatcher.cpp \
    src/utils/umkaauth.cpp \
    src/utils/watcherator.cpp \
    src/utils/watcherdb.cpp \
    src/wrappers/printerswrapper.cpp\
    src/wrappers/fswrapper.cpp\
    src/utils/syncsocketwrapper.cpp

RESOURCES += cashboxservice.qrc


CONFIG(debug, debug|release) {
    DESTDIR = $(BUILDPATH)/lib/debug
}
CONFIG(release, debug|release) {
    DESTDIR = $(BUILDPATH)/lib/release
}
