PRAGMA encoding = "UTF-8";;
PRAGMA auto_vacuum  = 1;;
PRAGMA page_size = 16384;;
PRAGMA cache_size = 16384;;

create table if not exists  metadata (
    id integer primary key,
    metadataVersion integer not null on conflict abort,
    ofdSettingsVersion integer not null on conflict abort
);;

create trigger if not exists onmetadatainsert
    before insert on metadata
    when ((new.id is null) or (new.id <> 0))
begin
    select raise(abort, 'single record!');
end;;;

--------------------------------------------------CASHIERS------------------------------------------
create table if not exists cashiers (
    id integer primary key,
    serverId integer,
    login text not null on conflict abort,
    name text not null on conflict abort,
    pass text,
    perms integer not null default 0,
    inn text
);;

create trigger if not exists cashiersupdate
    before update on cashiers
    when ((old.id  = 1) and(new.serverId > 0))
begin
    select raise(abort, 'super user!');
end;;;
create trigger if not exists cashiersupdate
    before delete on cashiers
    when (old.id  = 1)
begin
    select raise(abort, 'super user!');
end;;;
create index if not exists cashier_server_id on cashiers(serverId);;
create unique index if not exists cashier_logopass on cashiers(login, pass);;

--------------------------------------------------OFD-----------------------------------------------

create table if not exists SUPPORTED_OFD (
    inn text primary key,
    address text not null on conflict abort,
    port integer not null on conflict abort,
    dns text,
    queryInterval integer not null on conflict abort,
    url text not null on conflict abort,
    name text not null on conflict abort,
    shortName text not null on conflict abort,
    labelAddr text,
    labelPort integer,
    keysAddr text,
    keysPort integer,
    testTout integer,
    keysTout integer
);;

create table if not exists CURRENT_OFD (
    id integer primary key,
    inn text not null on conflict abort,
    address text not null on conflict abort,
    port integer not null on conflict abort,
    dns text,
    queryInterval integer not null on conflict abort,
    url text not null on conflict abort,
    labelAddr text,
    labelPort integer,
    keysAddr text,
    keysPort integer,
    testTout integer,
    keysTout integer
);;

-----------------------------------------------------------END-------------------------------------------------
insert into metadata (id, metadataVersion, ofdSettingsVersion) values (0, 1, 0);;
