PRAGMA encoding = "UTF-8";;
PRAGMA auto_vacuum  = 1;;
PRAGMA page_size = 16384;;
PRAGMA cache_size = 16384;;

create table if not exists  metadata (
    id integer primary key,
    metadataVersion integer not null on conflict abort
);;

create trigger if not exists onmetadatainsert
    before insert on metadata
    when ((new.id is null) or (new.id <> 0))
begin
    select raise(abort, 'single record!');
end;;;

-------------------------------------------DOCS-TEXT------------------------------------------------
create table if not exists docstext (
    id integer primary key,
    textType integer not null on conflict abort,
    txt text not null on conflict abort
);;

create unique index if not exists docstextcrc on docstext(textType, txt);;

-------------------------------------------DOCS-REGDATA---------------------------------------------
create table if not exists docsregdata (
    id integer primary key,
    fsNumber text not null on conflict abort,
    regNumber text not null on conflict abort,
    ownerInn text not null on conflict abort,
    ownerName text not null on conflict abort,
    ffd integer not null on conflict abort
);;

create unique index if not exists docsregdata_idx on docsregdata(fsNumber, regNumber, ownerInn, ownerName, ffd);;
create index if not exists docsregdata_fs on docsregdata(fsNumber);;
-------------------------------------------DOCS-PLACE-----------------------------------------------
create table if not exists docsplace (
    id integer primary key,
    address text,
    place text
);;

create unique index if not exists docsplace_idx on docsplace(address, place);;
---------------------------------------------------DOCS---------------------------------------------

create table if not exists documents (
    id integer primary key,
    docType integer not null on conflict abort,
    fd integer not null on conflict abort,
    cycle integer not null on conflict abort,
    dt text not null on conflict abort,
    externalId text not null on conflict abort,
    clientId text,
    regdataId integer not null on conflict abort,
    headerId integer,
    footerId integer,
    placeDataId integer not null on conflict abort,
    serverId integer,
    sendStatus integer,
    sendDt text
);;

create unique index if not exists documents_number on documents (fd, regdataId);;
create unique index if not exists documents_externalId on documents (externalId);;
create index if not exists documents_dt on documents(dt);;
create index if not exists documents_serverId on documents(serverId);;
create index if not exists documents_sendStatus on documents(sendStatus);;
create index if not exists documents_sendDt on documents(sendDt);;

--------------------------------------------DOCS-FIELDS---------------------------------------------
create table if not exists docsfields(
    id integer primary key,
    docId integer not null on conflict abort,
    name text not null on conflict abort,
    val text not null on conflict abort
);;
create index if not exists docsfields_docId on docsfields(docId);;
create index if not exists docsfields_name on docsfields(name);;
create index if not exists docsfields_docId_bane on docsfields(docId, name);;
------------------------------------------------END-------------------------------------------------
insert into metadata (id, metadataVersion) values (0, 1);;
