#ifndef CASHBOXSERVICEROOT_H
#define CASHBOXSERVICEROOT_H

#include <QObject>
#include <QPointer>


class CashboxServiceRoot : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(CashboxServiceRoot)
public:
    static int start(int &argc, char *argv[]);
    static CashboxServiceRoot* instance() {return _instance;}
public slots:
    void setUpLocale(const QLocale &locale);
    void setUpLocale();
signals:
    void sendToOfd();
private:
    static CashboxServiceRoot* _instance;
    int * argc_;
    char ** argv_;
    QPointer<QThread> coreWorker_;
    QPointer<QThread> ofdWorker_;
    QPointer<QThread> oismWorker_;
//    MerchantConfigManager *qrConfigMgr_;

    CashboxServiceRoot(int &argc, char *argv[]);
    virtual ~CashboxServiceRoot() override;

    void doSetupLocale(const QLocale &locale);
    bool createApplication();

    bool init();
    int exec();
    void stop();
    void stopThread(QPointer<QThread> &t);
private slots:
    void startAfterExec();
};

#define serviceRoot CashboxServiceRoot::instance()

#endif // CASHBOXSERVICEROOT_H
