#include "basetaskprocessor.h"
#include "printdocumentformatter.h"
#include "logmanip.h"
#include "internalobjectsorage.h"

BaseTaskProcessor::~BaseTaskProcessor()
{

}

bool BaseTaskProcessor::checkState(const CoreTransaction &task, CoreApiResult &result)
{
    if(task.printResult())
    {
        CoreApiConst::ErrorCode err = printer_->test();
        if(err != CoreApiConst::ErrorCode::Ok)
        {
            lmWarning() << CoreApiConst::defaultErrorMsg(err);
            result = CoreApiResult(err);
            return false;
        }
    }
    return true;
}


BaseTaskProcessor::BaseTaskProcessor(FsWrapper *fs, ProcessingDataWrapper *dw, PrintersWrapper *p,
                                     QObject *parent)
    : QObject(parent)
    , fs_(fs)
    , pdw_(dw)
    , printer_(p)
{

}

CoreApiConst::ErrorCode BaseTaskProcessor::printTextDoc(const TextPrinterDocument &doc)
{
    CoreApiConst::ErrorCode err = CoreApiConst::ErrorCode::Ok;
    if(printer_->printTextDocument(doc))
    {
//        pdw_->removeTempDoc();
    }
    else
    {
        err = printer_->lastErrorCode();
        if(err == CoreApiConst::ErrorCode::Ok)
        {
            err = CoreApiConst::ErrorCode::PrinterBaseError;
        }
    }
    return err;
}
