#ifndef BASETASKPROCESSOR_H
#define BASETASKPROCESSOR_H

#include "printerswrapper.h"
#include "processingdatawrapper.h"
#include "coretransaction.h"
#include "coreapiresult.h"
#include "fswrapper.h"
#include <QObject>

class BaseTaskProcessor : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(BaseTaskProcessor)
public:
    ~BaseTaskProcessor() override;


    virtual bool checkState(const CoreTransaction &task, CoreApiResult &result);

signals:
protected:
    FsWrapper *fs_;
    ProcessingDataWrapper *pdw_;
    PrintersWrapper *printer_;

    BaseTaskProcessor(FsWrapper *fs, ProcessingDataWrapper *dw, PrintersWrapper *p,
            QObject *parent = nullptr);

    virtual CoreApiConst::ErrorCode printTextDoc(const TextPrinterDocument &doc);
};

#endif // BASETASKPROCESSOR_H
