#ifndef SYNCSOCKETWRAPPER_H
#define SYNCSOCKETWRAPPER_H

#include <QObject>
#include <QTcpSocket>
#include <QEventLoop>
#include <QTimer>
#include <functional>
#include <QElapsedTimer>
#include <QLoggingCategory>


//TODO: Переделать луп с лямюдой check и общим таймаутом как в старом в банковских воркерах


using ReadFunc=std::function<QByteArray (QTcpSocket *socket) >;

class SyncSocketWrapper : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(SyncSocketWrapper)
public:
    explicit SyncSocketWrapper(const char *log, QObject *parent = nullptr);
    ~SyncSocketWrapper() override;

    bool connectedToHost() const;


    bool connectToHost(const QString &host, quint16 port);
    bool disconnectFromHost();
    QByteArray sendMsg(const QByteArray &msg, ReadFunc reader);


    qint32 exchangeTimeout() const;
    void setExchangeTimeout(qint32 newExchangeTimeout);

    QTcpSocket::SocketState socketState() const;

private:
    QLoggingCategory log_;
    QTcpSocket *socket_;
    QEventLoop *loop_;
    QTimer *loopTimer_;
    QElapsedTimer timer_;
    qint32 exchangeTimeout_;

    QTcpSocket *socket();
    QEventLoop *loop();
    QTimer *timer();


    void execLoop(qint32 timeout);

private slots:
    void timeout();
    void connected();
    void disconnected();
    void errorOccurred(QAbstractSocket::SocketError socketError);
    void hostFound();
    void proxyAuthenticationRequired(const QNetworkProxy &proxy, QAuthenticator *authenticator);
    void stateChanged(QAbstractSocket::SocketState socketState);
    void readyRead();
};

#endif // SYNCSOCKETWRAPPER_H
