#ifndef WATCHERATOR_H
#define WATCHERATOR_H

#include "processingdatawrapper.h"

class Watcherator
{
    Q_DISABLE_COPY(Watcherator)
public:
    Watcherator(PrintDocWatcher *watcher, const CoreTransaction &trans, qint32 docNumber);
    ~Watcherator();

    bool init();
    bool startFs();
    bool update(qint32 docNumber,  const QVariantMap &doc,
                const TextPrinterDocument &printable);
    bool finalize(CoreApiConst::ErrorCode result);
    bool remove();

    //Вызывается при ошибке хранилища
    CoreApiResult toErrorResult();

    qint32 docNumber() const;
    void clean();

private:
    PrintDocWatcher *watcher_;
    CoreTransaction transaction_;
    qint32 docNumber_;
    CoreApiConst::ErrorCode lastError_;
    QString lastErrorMsg_;
    bool needRemove_;
};

#endif // WATCHERATOR_H
