PRAGMA encoding = "UTF-8";;
PRAGMA auto_vacuum  = 1;;
PRAGMA page_size = 16384;;
PRAGMA cache_size = 16384;;

create table if not exists  metadata (
    id integer primary key,
    metadataVersion integer not null on conflict abort,
    fsNumber text,
    keysLastUpdatesDt text
);;

create trigger if not exists onmetadatainsert
    before insert on metadata
    when ((new.id is null) or (new.id <> 0))
begin
    select raise(abort, 'single record!');
end;;;


create table if not exists docs (
    id integer primary key,
    externalId text not null on conflict abort,
    transactionType integer not null on conflict abort,
    clientId text,
    docNumber integer not null on conflict abort,
    incoming text not null on conflict abort,
    dt text not null on conflict abort,
    status integer not null on conflict abort,
    result integer,
    outgoing text,
    printable text
);;

create unique index if not exists docs_externalId on docs(externalId);;
create index if not exists docs_clientId on docs(clientId);;
create index if not exists docs_status on docs(status);;
create index if not exists docs_dt on docs(dt);;
create index if not exists docs_docNumber on docs(docNumber);;

create table if not exists labelsFlags (
    id integer primary key,
    flag2112 integer not null on conflict abort,
    flag2113 integer not null on conflict abort
);;



-----------------------------------------------------------END-------------------------------------------------
insert into metadata (id, metadataVersion) values (0, 1);;
