QT += quick androidextras network sql concurrent websockets multimedia serialport

CONFIG += c++17
DEFINES += CASHBOX_UI
# You can make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

INCLUDEPATH += src src/handlers src/wrappers src/utils src/models src/logs src/cfg

include($$(CASHBOX_CONF))
include($$(CASHBOXAPI_LIB)/cashboxapilib.pri)
include(src/logs/smtpclient/smtpclient.pri)

CONFIG += qmltypes
QML_IMPORT_NAME = ru.armax.cashbox
QML_IMPORT_MAJOR_VERSION = 1


# Additional import path used to resolve QML modules in Qt Creator's code model
QML_IMPORT_PATH =

# Additional import path used to resolve QML modules just for Qt Quick Designer
QML_DESIGNER_IMPORT_PATH =


# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target


ANDROID_ABIS = armeabi-v7a

contains(ANDROID_TARGET_ARCH,armeabi-v7a) {
    ANDROID_ABIS = \
        armeabi-v7a
}

HEADERS += \
    src/baseqmlapproot.h \
    src/cashboxroot.h \
    src/handlers/approothandler.h \
    src/handlers/basecoreconfighandler.h \
    src/handlers/basecorehandler.h \
    src/handlers/fiscalizationhandler.h \
    src/handlers/loginhandler.h \
    src/handlers/receiptconfighandler.h \
    src/handlers/receipthandler.h \
    src/handlers/reportscorehandler.h \
    src/logs/sendmailhelper.h \
    src/logs/supportmailer.h \
    src/models/basecatalogmodel.h \
    src/models/cashiersmodel.h \
    src/models/industrypropsmodel.h \
    src/models/mainmenumodel.h \
    src/models/receiptmodel.h \
    src/uicashboxserviceapi.h\
    src/utils/hexstringvalidator.h \
    src/utils/innvalidator.h \
    src/utils/regnumbervalidator.h \
    src/utils/runtimeuisettings.h \
    src/utils/sbarcodefilter.h \
    src/utils/serialcheker.h \
    src/wrappers/agentdatawrapper.h \
    src/wrappers/basecatalogitemwrapper.h \
    src/wrappers/baseworkincomingwrapper.h \
    src/wrappers/cashboxstatuswrapper.h \
    src/wrappers/cashierwrapper.h \
    src/wrappers/incomingregwrapper.h \
    src/wrappers/ofdsettingswrapper.h \
    src/wrappers/receiptoperationwrapper.h \
    src/wrappers/sessionwrapper.h \
    src/wrappers/simplereceiptoperationwrapper.h

SOURCES += \
    src/handlers/approothandler.cpp \
    src/handlers/basecoreconfighandler.cpp \
    src/handlers/basecorehandler.cpp \
    src/handlers/fiscalizationhandler.cpp \
    src/handlers/loginhandler.cpp \
    src/handlers/receiptconfighandler.cpp \
    src/handlers/receipthandler.cpp \
    src/handlers/reportscorehandler.cpp \
    src/logs/sendmailhelper.cpp \
    src/logs/supportmailer.cpp \
    src/main.cpp \
    src/baseqmlapproot.cpp \
    src/cashboxroot.cpp \
    src/models/basecatalogmodel.cpp \
    src/models/cashiersmodel.cpp \
    src/models/industrypropsmodel.cpp \
    src/models/mainmenumodel.cpp \
    src/models/receiptmodel.cpp \
    src/uicashboxserviceapi.cpp \
    src/utils/hexstringvalidator.cpp \
    src/utils/innvalidator.cpp \
    src/utils/regnumbervalidator.cpp \
    src/utils/runtimeuisettings.cpp \
    src/utils/sbarcodefilter.cpp \
    src/utils/serialcheker.cpp \
    src/wrappers/agentdatawrapper.cpp \
    src/wrappers/basecatalogitemwrapper.cpp \
    src/wrappers/baseworkincomingwrapper.cpp \
    src/wrappers/cashboxstatuswrapper.cpp \
    src/wrappers/cashierwrapper.cpp \
    src/wrappers/incomingregwrapper.cpp \
    src/wrappers/ofdsettingswrapper.cpp \
    src/wrappers/receiptoperationwrapper.cpp \
    src/wrappers/sessionwrapper.cpp \
    src/wrappers/simplereceiptoperationwrapper.cpp

RESOURCES += \
    translations/translations.qrc




