import QtQuick 2.15
import QtQuick.Controls 2.15
import Qt.labs.platform 1.1

SpinBox {
    editable: true

    property int decimals: 2
    property real realValue: value / 100

    validator: DoubleValidator {
        bottom: Math.min(parent.from, parent.to)
        top:  Math.max(parent.from, parent.to)
    }

    textFromValue: function(value, locale) {
        return Number(value / stepSize).toLocaleString(locale, 'f', decimals)
    }

    valueFromText: function(text, locale) {
        return Number.fromLocaleString(locale, text) * stepSize
    }
}
