import QtQuick 2.12
import QtQuick.Controls 2.15

import Qt.labs.platform 1.1 as QtLabs

import ru.armax.cashbox 1.0

//import ru.armax.cashbox.cashboxstatus 1.0
//import ru.armax.cashbox.approot 1.0

Page {
    width: parent.width
    height: parent.height
    signal closed()
    title: qsTr("Очистка МГМ")
    id: fsCleanPage
    objectName: "fsCleanPage"
    property alias ownFooter: footer

    property string firmwareFileName: ""


    AppRoot {
        id: appRoot
        onShowBusy: function(busy) {
            busyIndicator.running = busy
            fsCleanPage.enabled = !busy
            window.enableAll(!busy)
        }
        onError: function(txt) {
            msgError.text = txt
            busyIndicator.running = false
            fsCleanPage.enabled = true
            window.enableAll(true)
            msgError.open()
        }

        onSuccessClean: {
            msgSuccess.text = "МГМ ПОЧИЩЕН УСПЕШНО!"
            busyIndicator.running = false
            fsCleanPage.enabled = true
            window.enableAll(true)
            msgSuccess.open()
        }
    }
    BusyIndicator {
        id: busyIndicator
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.verticalCenter: parent.verticalCenter
        running: false
        z: 10
    }
    QtLabs.MessageDialog {
        id: msgError
        buttons: QtLabs.MessageDialog.Close
        text: ""
    }

    QtLabs.MessageDialog {
        id: msgSuccess
        buttons: QtLabs.MessageDialog.Ok
        text: ""
        onOkClicked: {
            fsCleanPage.closed()
        }
    }
    Label {
        anchors.fill: parent
        horizontalAlignment: Label.AlignHCenter
        verticalAlignment: Label.AlignVCenter
        color: "red"
        wrapMode: Label.WordWrap
        text: "Внимание!\nПосле очистки МГМ для дальнейшей работы будет необходимо заново зарегистрировать ККТ\nВсе документы в МГМ безвозвратно исчезнут!"
    }

    ToolBar {
        id: footer
        height: 70
        ToolButton {
            id: tbBack
            width: 64
            height: 64
            anchors.left: parent.left
            anchors.verticalCenter: parent.verticalCenter
            anchors.leftMargin: 10
            anchors.rightMargin: 10
            anchors.topMargin: 5
            anchors.bottomMargin: 5
            icon.source: "qrc:/icons/home_64.png"
            icon.color: "transparent"
            icon.width: 60
            icon.height: 60
            onClicked: {
                fsCleanPage.closed()
            }
        }
        ToolButton {
            id: tbCheck
            width: 64
            height: 64
            anchors.right: parent.right
            anchors.verticalCenter: parent.verticalCenter
            anchors.leftMargin: 10
            anchors.rightMargin: 10
            anchors.topMargin: 5
            anchors.bottomMargin: 5
            icon.source: "qrc:/icons/clean_mgm_64.png"
            icon.color: "transparent"
            icon.width: 64
            icon.height: 64
            onClicked: {
                appRoot.fsClean()
            }
        }
    }
    Component.onCompleted: {
        width = parent.width
        height = parent.height
    }
}
