import QtQuick 2.12
import QtQuick.Controls 2.15

import ru.armax.cashbox 1.0

//import ru.armax.cashbox.industrypropertywrapper 1.0


Dialog {
    modal: true
    title: qsTr("Отраслевой реквизит")
    standardButtons: Dialog.Cancel

    property alias editVal: prop.prop
    property alias ownProp: prop
    property int curIdx: -1

    IndustryPropertyWrapper {
        id: prop
        onIsValidChanged: {
            if(prop.isValid) lError.text = ""
            else lError.text = "Не все поля заполнены"
        }
    }

    Label {
        id: lFedId
        text: qsTr("ФОИВ ИД")
        anchors.left:  parent.left
        anchors.verticalCenter: leFedId.verticalCenter
    }
    TextField {
        id: leFedId
        anchors.top: parent.top
        anchors.right: parent.right
        text: prop.fedId
        maximumLength: 3
        inputMethodHints: Qt.ImhDigitsOnly
        onTextEdited: {
            prop.fedId = leFedId.text
        }
    }
    Label {
        id: lDocdt
        anchors.left: parent.left
        anchors.verticalCenter: leDocDt.verticalCenter
        text: qsTr("Дата ДО")
    }
    TextField {
        id: leDocDt
        anchors.top: leFedId.bottom
        anchors.right: parent.right
        text: prop.docDt
        maximumLength: 10
        inputMask: "99.99.9999;-"
        inputMethodHints: Qt.ImhDate
        onEditingFinished: {
            prop.docDt = leDocDt.text
        }
    }
    Label {
        id: lDocNum
        anchors.left: parent.left
        anchors.verticalCenter: leDocNum.verticalCenter
        text: qsTr("Номер ДО")
    }
    TextField {
        id: leDocNum
        anchors.top: leDocDt.bottom
        anchors.right: parent.right
        text: prop.docNumber
        maximumLength: 32
        onEditingFinished: {
            prop.docNumber = leDocNum.text
        }
    }

    Label {
        id: lVal
        anchors.top: leDocNum.bottom
        anchors.right: parent.right
        text: qsTr("Значение отраслевого реквизита")
    }
    TextField {
        id: leVal
        anchors.top: lVal.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        text: prop.value
        maximumLength: 256
        onEditingFinished: {
            prop.value = leVal.text
        }
    }
    Label {
        id: lError
        anchors.top: leVal.bottom
        anchors.right: parent.right
        anchors.left: parent.left
        horizontalAlignment: Label.AlignHCenter
        color: "red"
        text: ""
    }
    RoundButton {
        id: rbApply
        anchors.margins: 10
        anchors.top: lError.bottom
        anchors.horizontalCenter: lError.horizontalCenter
        icon.source: "qrc:/icons/apply_64.png"
        icon.color: "transparent"
        icon.width: 50
        icon.height: 50
        enabled: prop.isValid
        z:100
        onPressed: {
            accept()
        }
    }


}
