import QtQuick 2.12
import QtQuick.Controls 2.15
import QtQuick.Controls.Material 2.15


Dialog {
    modal: true
    title: qsTr("Продолжить оформление, если ")
    standardButtons: Dialog.Cancel | Dialog.Ok
    bottomPadding: 0
    topPadding: 0
    property int flags: 0
    property bool canSkipB5: false

    CheckBox {
        id: cbSkipFsResult
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.bottomMargin: 0
        bottomPadding: 0
        text: "Марку не удалось проверить в ФН"
        contentItem: Label {
            text: cbSkipFsResult.text
            font: cbSkipFsResult.font

            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
            bottomPadding: 0
            topPadding: 0
            leftPadding: cbSkipFsResult.indicator.width + cbSkipFsResult.spacing
            wrapMode: Label.WordWrap
        }
        onReleased: {
            if(cbSkipFsResult.checked) flags = flags | 1
            else flags = flags & 254
        }
    }
    CheckBox {
        id: cbSkipFsWrong
        anchors.top: cbSkipFsResult.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.bottomMargin: 0
        anchors.topMargin: 0
        bottomPadding: 0
        text: "Результат проверки марки в ФН отрицательный"
        contentItem: Label {
            text: cbSkipFsWrong.text
            font: cbSkipFsWrong.font
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
            bottomPadding: 0
            topPadding: 0
            leftPadding: cbSkipFsWrong.indicator.width + cbSkipFsWrong.spacing
            wrapMode: Label.WordWrap
        }
        onReleased: {
            if(cbSkipFsWrong.checked) flags = flags | 2
            else flags = flags & 253
        }
    }
    CheckBox {
        id: cbSkipNetworkError
        anchors.top: cbSkipFsWrong.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.bottomMargin: 0
        anchors.topMargin: 0
        bottomPadding: 0

        text: "Нет связи с сервером ОИСМ"
        contentItem: Label {
            text: cbSkipNetworkError.text
            font: cbSkipNetworkError.font
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
            bottomPadding: 0
            topPadding: 0
            leftPadding: cbSkipNetworkError.indicator.width + cbSkipNetworkError.spacing
            wrapMode: Label.WordWrap
        }
        onReleased: {
            if(cbSkipNetworkError.checked) flags = flags | 4
            else flags = flags & 251
        }
    }
    CheckBox {
        id: cbSkipIfRequestError
        anchors.top: cbSkipNetworkError.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.bottomMargin: 0
        bottomPadding: 0

        text: "Результат проверки марки отрицательный"
        contentItem: Label {
            text: cbSkipIfRequestError.text
            font: cbSkipIfRequestError.font
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
            bottomPadding: 0
            topPadding: 0
            leftPadding: cbSkipIfRequestError.indicator.width + cbSkipIfRequestError.spacing
            wrapMode: Label.WordWrap
        }
        onReleased: {
            if(cbSkipIfRequestError.checked) flags = flags | 8
            else flags = flags & 247
        }
    }
    CheckBox {
        id: cbSkipIsStatusError
        anchors.top: cbSkipIfRequestError.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.bottomMargin: 0
        anchors.topMargin: 0
        text: "Некорректный статус товара"
        contentItem: Label {
            text: cbSkipIsStatusError.text
            font: cbSkipIsStatusError.font
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
            bottomPadding: 0
            topPadding: 0
            leftPadding: cbSkipIsStatusError.indicator.width + cbSkipIsStatusError.spacing
            wrapMode: Label.WordWrap
        }
        onReleased: {
            if(cbSkipIsStatusError.checked) flags = flags | 16
            else flags = flags & 239
        }
    }
    Rectangle {
        id:rTetminator
        height: 2
        border.color: 'black'
        border.width: 2
        anchors.top: cbSkipIsStatusError.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.bottomMargin: 0
        anchors.topMargin: 0
    }

    CheckBox {
        id: cbSkipB5
        anchors.top: cbSkipIsStatusError.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.bottomMargin: 0
        anchors.topMargin: 0
        font.bold: true
        text: "Не формировать запрос о коде маркировки"
        contentItem: Label {
            text: cbSkipB5.text
            font: cbSkipB5.font
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
            bottomPadding: 0
            topPadding: 0
            color: Material.primary
            leftPadding: cbSkipB5.indicator.width + cbSkipB5.spacing
            wrapMode: Label.WordWrap
        }
        onReleased: {
            if(cbSkipB5.checked) flags = flags | 32
            else flags = flags & 223
        }
    }
}
