import QtQuick 2.12
import QtQuick.Controls 2.12
import Qt.labs.platform 1.1

import ru.armax.cashbox 1.0

Page {
    id: loginPage
    width: parent.width
    height: parent.height
    signal closed()
    title: ""
    objectName: "loginPage"

    LoginHandler {
        id: loginHandler
        onLoginned: {
            window.goHome()
        }
        onShowBusy: function(busy) {
            busyIndicator.running = busy
            loginPage.enabled = !busy
            window.enableAll(!busy)
        }
        onError: function(txt) {
            msgError.text = txt
            msgError.open()
        }
    }
    BusyIndicator {
        id: busyIndicator
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.verticalCenter: parent.verticalCenter
        running: false
        z: 100
    }
    MessageDialog {
        id: msgError
        buttons: MessageDialog.Close
        text: ""
    }

    Item {
        id: img
        anchors.top: parent.top
        anchors.horizontalCenter: parent.horizontalCenter
        width: 200
        height: 200
        Image {
            anchors.fill: parent
            id: imgTram
            source: "icons/medved.png"
            fillMode: Image.Stretch
        }
    }
    Item {
        id: loginItem
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.margins: 10
        anchors.top: img.bottom
        height: contentHeight
        width: parent.width
        ComboBox {
            id: cbCashier
            width: parent.width
            height: 80
            model: loginHandler.cashiersModel
            textRole: "name"
            inputMethodHints:  Qt.ImhDialableCharactersOnly
            z: 100
            font.pixelSize: 24
            padding: 10
            anchors.margins: 20
            anchors.top: parent.top
        }
        TextField {
            id: lePassword
            anchors.top: cbCashier.bottom
            width: parent.width
            horizontalAlignment: TextInput.AlignHCenter
            padding: 10
            z: 100
            font.pixelSize: 24
            echoMode: TextInput.Password
            anchors.margins: 20
            onPressed: {
                forceActiveFocus(Qt.MouseFocusReason)
                Qt.inputMethod.show()
            }
            onAccepted: {
                loginHandler.login(cbCashier.model[cbCashier.currentIndex].login, lePassword.text)
            }
        }
        Button {
            id: btnLogin
            text: qsTr("Вход")
            anchors.top: lePassword.bottom
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.margins: 20
            onPressed: loginHandler.login(cbCashier.model[cbCashier.currentIndex].login, lePassword.text)
        }

    }

}
