import QtQuick 2.12
import QtQuick.Controls 2.12
import Qt.labs.platform 1.1

//TODO:  Переделать расчет сдачи: при продаже не учитывать нал для расчета ограничений спинбоксов

Page {
    width: parent.width
    height: parent.height
    id: payEditPage
    signal closed()
    title: qsTr("Оплата")
    objectName: "payEditPage"
    property alias ownFooter: footer
    property double amount: 0.0
    property double cash: 0.0
    property double card: 0.0
    property double prepay: 0.0
    property double postpay: 0.0
    property double barter: 0.0
    property double change: 0.0
    property bool isSale: true

    signal accepted(double cash, double card, double prepay, double postpay, double barter)

    Label {
        id: lAmountCaption
        anchors.top: parent.top
        anchors.leftMargin: 10
        anchors.rightMargin:10
        anchors.left: parent.left
        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 24
        text: qsTr("К оплате")
    }
    Label {
        id: lAmount
        anchors.top: parent.top
        anchors.right: parent.right
        anchors.leftMargin: 10
        anchors.rightMargin:10
        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 24
        color: "blue"
        text: ""
    }
    Label {
        id: lChangeCaption
        anchors.top: lAmount.bottom
        anchors.left: parent.left
        anchors.leftMargin: 10
        anchors.rightMargin:10
        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 24
        text: qsTr("Сдача")
        visible: isSale
    }
    Label {
        id: lChange
        anchors.right: parent.right
        anchors.top: lAmount.bottom
        anchors.leftMargin: 10
        anchors.rightMargin:10
        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 24
        color: "green"
        text: ""
        visible: isSale
    }
    Label {
        id: lCashCaption
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: lChange.bottom
        anchors.leftMargin: 10
        anchors.rightMargin:10

        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 16
        text: qsTr("Наличными")
    }
    DoubleSpinBox {
        id: dsbCash
        anchors.leftMargin: 10
        anchors.rightMargin:10
        anchors.top: lCashCaption.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        from: 0
        value: 0
        to: isSale ? 2147483647 : payEditPage.amount * 100 - dsbPrepay.value - dsbCard.value - dsbBarter.value - dsbPostpay.value
        stepSize: 100
        font.pixelSize: 20
        editable: true
        decimals: 2
        realValue: value / 100.0
        onValueChanged: {
            payEditPage.cash = dsbCash.value / 100.0
            calcChange()
        }
    }
    Label {
        id: lCardCaption
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: dsbCash.bottom
        anchors.leftMargin: 10
        anchors.rightMargin:10
        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 16
        text: qsTr("Картой")
    }
    DoubleSpinBox {
        id: dsbCard
        anchors.leftMargin: 10
        anchors.rightMargin:10

        anchors.top: lCardCaption.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        font.pixelSize: 20
        from: 0
        value: 0
        to: payEditPage.amount * 100 - dsbCash.value - dsbPrepay.value - dsbBarter.value - dsbPostpay.value
        stepSize: 100
        editable: true
        decimals: 2
        realValue: value / 100.0
        onValueChanged: {
            payEditPage.card = dsbCard.value / 100.0
            calcChange()
        }
    }

    Label {
        id: lPrepayCaption
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: dsbCard.bottom
        anchors.leftMargin: 10
        anchors.rightMargin:10

        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 16
        text: qsTr("Предоплатой")
    }
    DoubleSpinBox {
        id: dsbPrepay
        anchors.leftMargin: 10
        anchors.rightMargin:10
        anchors.top: lPrepayCaption.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        from: 0
        value: 0
        to: payEditPage.amount * 100 - dsbCash.value - dsbCard.value - dsbBarter.value - dsbPostpay.value

        stepSize: 100
        font.pixelSize: 20
        editable: true
        decimals: 2
        realValue: value / 100.0
        onValueChanged: {
            payEditPage.prepay = dsbPrepay.value / 100.0
            calcChange()
        }
    }
    Label {
        id: lPostpayCaption
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: dsbPrepay.bottom
        anchors.leftMargin: 10
        anchors.rightMargin:10
        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 16
        text: qsTr("Постоплатой")
    }
    DoubleSpinBox {
        id: dsbPostpay
        anchors.leftMargin: 10
        anchors.rightMargin:10

        anchors.top: lPostpayCaption.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        font.pixelSize: 20
        from: 0
        value: 0
        to: payEditPage.amount * 100 - dsbCash.value - dsbCard.value - dsbBarter.value - dsbPrepay.value

        stepSize: 100
        editable: true
        decimals: 2
        realValue: value / 100.0
        onValueChanged: {
            payEditPage.postpay = dsbPostpay.value / 100.0
            calcChange()
        }
    }

    Label {
        id: lBarterCaption
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: dsbPostpay.bottom
        anchors.leftMargin: 10
        anchors.rightMargin:10
        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 16
        text: qsTr("Встречным предоставлением")
    }
    DoubleSpinBox {
        id: dsbBarter
        anchors.leftMargin: 10
        anchors.rightMargin:10

        anchors.top: lBarterCaption.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        font.pixelSize: 20
        from: 0
        value: 0
        to: payEditPage.amount * 100 - dsbCash.value - dsbCard.value - dsbPrepay.value - dsbPostpay.value
        stepSize: 100
        editable: true
        decimals: 2
        realValue: value / 100.0
        onValueChanged: {
            payEditPage.barter = dsbBarter.value / 100.0
            calcChange()
        }
    }

    ToolButton {
        id: tbCash
        icon.source: "qrc:/icons/cash_64.png"
        icon.color: "transparent"
        icon.width: 64
        icon.height: 64
        anchors.margins: 5
        anchors.bottom: parent.bottom
        width: 80
        height: width
        anchors.left: parent.left
        onPressed: {
            if(amount - card > 0.0) {
                cash = amount - card
                dsbCash.value = (amount - card) * 100
            }
            calcChange()
        }
    }

    ToolButton {
        id: tbClear
        icon.source: "qrc:/icons/clear_64.png"
        icon.color: "transparent"
        icon.width: 64
        icon.height: 64
        anchors.margins: 5
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.bottom: parent.bottom
        width: 80
        height: width
        onPressed: {
            dsbCard.value = 0
            dsbCash.value = 0
            cash = 0.0
            card = 0.0
            calcChange()
        }
    }
    ToolButton {
        id: tbCard
        icon.source: "qrc:/icons/card_64.png"
        icon.color: "transparent"
        icon.width: 64
        icon.height: 64
        anchors.margins: 5
        anchors.bottom: parent.bottom
        anchors.right: parent.right
        width: 80
        height: width

        onPressed: {
            if(amount - cash > 0.0) {
                card = amount - card
                dsbCard.value = (amount - cash) * 100
            }
            calcChange()
        }
    }

    MessageDialog {
        id: msgError
        buttons: MessageDialog.Close
        text: ""
    }


    ToolBar {
        id: footer
        height: 70
        ToolButton {
            id: tbBack
            width: 64
            height: 64
            anchors.left: parent.left
            anchors.verticalCenter: parent.verticalCenter
            anchors.margins: 5
            icon.source: "qrc:/icons/back_64.png"
            icon.color: "transparent"
            icon.width: 64
            icon.height: 64
            onClicked: {
                payEditPage.closed()
            }
        }
        ToolButton {
            id: tbSave
            width: 64
            height: 64
            anchors.right: parent.right
            anchors.verticalCenter: parent.verticalCenter
            anchors.margins: 5
            icon.source: "qrc:/icons/submit_64.png"
            icon.color: "transparent"
            icon.width: 64
            icon.height: 64
            onClicked: {
                payEditPage.accepted(cash, card, prepay, postpay, barter)
                payEditPage.closed()
            }
        }
    }

    function calcChange() {
        dsbCash.enabled = true
        dsbCard.enabled = true
        dsbPostpay.enabled = true
        dsbPrepay.enabled = true
        dsbBarter.enabled = true
        if(cash >= amount) {
            dsbCard.value = 0
            dsbPostpay.value = 0
            dsbPrepay.value = 0
            dsbBarter.value = 0
            dsbCard.enabled = false
            dsbPostpay.enabled = false
            dsbPrepay.enabled = false
            dsbBarter.enabled = false
        }
        if(card > amount) {
            dsbCard.value = amount * 100
            card = amount
        }
        if(card === amount) {
            dsbCard.enabled = false
        }
        if(isSale) {
            change = cash - (amount - card -prepay - postpay - barter)
            if(change < 0.0) change = 0.0
        }
        lAmount.text = Number(amount).toLocaleString(Qt.locale("uz_UZ"), 'f', 2)
        lChange.text = Number(change).toLocaleString(Qt.locale("uz_UZ"), 'f', 2)
    }

    Component.onCompleted: {
        calcChange()
    }
}
