package ru.armax.cashbox;


import android.os.Environment;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.app.Activity;
import android.os.Build;
import android.app.Service;

import java.lang.String;
import java.text.SimpleDateFormat;
import java.util.Date;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.util.Log;
import android.telephony.TelephonyManager;
import java.util.Hashtable;
import java.util.Vector;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import com.google.zxing.MultiFormatReader;
import com.google.zxing.oned.MultiFormatUPCEANReader;
import com.google.zxing.oned.EAN13Reader;
import com.google.zxing.Result;
import com.google.zxing.DecodeHintType;
import com.google.zxing.BarcodeFormat;
import com.google.zxing.BinaryBitmap;
import com.google.zxing.RGBLuminanceSource;
import com.google.zxing.common.HybridBinarizer;
import android.os.BatteryManager;

import java.net.NetworkInterface;
import java.util.Enumeration;
import java.util.List;
import android.content.pm.ApplicationInfo;
import java.io.File;
import androidx.core.content.ContextCompat;
import android.net.Uri;
import android.app.NotificationManager;
import android.app.Notification;
import android.app.PendingIntent;
import android.os.StrictMode.VmPolicy;
import android.os.StrictMode;
import android.os.StrictMode.VmPolicy.Builder;
import android.app.NotificationManager;
import android.app.NotificationChannel;
import java.io.FileOutputStream;

import com.pos.sdk.accessory.PosAccessoryManager;

public class AndroidApiHelper extends Object {

    private Context mContext;
    public AndroidApiHelper(Context context) {
        mContext = context;
    }
    public String getDsn() {
        try {
            PosAccessoryManager pam = PosAccessoryManager.getDefault();
            return pam.getVersion(PosAccessoryManager.VERSION_TYPE_DSN);
        }
        catch(Exception e) {
            e.printStackTrace();
            return "unknown";
        }
//        return Build.SERIAL;
    }
    public void showDateTimeSettings() {
        Intent intent = new Intent(android.provider.Settings.ACTION_DATE_SETTINGS);
        try {
            intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            mContext.startActivity(intent);
        }
        catch(Exception e) {
//            e.prinStackView();
        }
    }
    public String packageName() {
            try {
                return mContext.getPackageName();

            } catch (Exception e) {
                e.printStackTrace();
            }
            return new String();
        }
    public String versionName() {
            try {
                PackageInfo pInfo = mContext.getPackageManager().getPackageInfo(mContext.getPackageName(), 0);
                return pInfo.versionName;
            } catch (PackageManager.NameNotFoundException e) {
                e.printStackTrace();
            }
            return new String();
        }
    public long versionCode() {
            try {
                PackageInfo pInfo = mContext.getPackageManager().getPackageInfo(mContext.getPackageName(), 0);
               return pInfo.versionCode;
            } catch (PackageManager.NameNotFoundException e) {
                e.printStackTrace();
            }
            return -1;
        }

    public String packagePath() {
            try {
                PackageManager packageManager = mContext.getPackageManager();
                PackageInfo packageInfo = packageManager.getPackageInfo(mContext.getPackageName(), 0);
                Log.w("TEST", packageInfo.packageName + "/" + mContext.getPackageName());
                ApplicationInfo applicationInfo = packageInfo.applicationInfo;
                Log.w("TEST", applicationInfo.publicSourceDir + "/" + applicationInfo.packageName);
                File apkFile = new File(applicationInfo.publicSourceDir);
                if (apkFile.exists()) {
                    Log.w("TEST", apkFile.getAbsolutePath() + "/" + applicationInfo.packageName);
                    return apkFile.getAbsolutePath();
                    }
            } catch (Exception e) {
                e.printStackTrace();
            }
            return new String();
        }
    public String filePackageName(String path) {
            try {
                PackageInfo pInfo = mContext.getPackageManager().getPackageArchiveInfo(path, 0);
                return pInfo.packageName;
            } catch (Exception e) {
                e.printStackTrace();
            }
            return new String();
        }
    public String fileVersionName(String path) {
            try {
                PackageInfo pInfo = mContext.getPackageManager().getPackageArchiveInfo(path, 0);
                return pInfo.versionName;
            } catch (Exception e) {
                e.printStackTrace();
            }
            return new String();
        }
    public long fileVersionCode(String path) {
            try {
                PackageInfo pInfo = mContext.getPackageManager().getPackageArchiveInfo(path, 0);
                return pInfo.versionCode;
            } catch (Exception e) {
                e.printStackTrace();
            }
            return -1;
        }
    public void initApp(String path) {
        FileOutputStream outputStream = null;
        try {
            Log.w("TEST", "initApp 1");
            outputStream = new FileOutputStream("/sys/devices/virtual/misc/fiscal/power_en");
            outputStream.write("1".getBytes());
            Log.w("TEST", "initApp 2");
        } catch (Exception e) {
            Log.w("TEST", "initApp 3");
            e.printStackTrace();
        } finally {
            if (outputStream != null)
            {
                try {
                    outputStream.close();
                    }
                catch (Exception e) {
                            //
                    }
            }
        }
        }
    public void releaseApp() {
        FileOutputStream outputStream = null;
        try {
            outputStream = new FileOutputStream("/sys/devices/virtual/misc/fiscal/power_en");
            outputStream.write("0".getBytes());
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (outputStream != null)
            {
                try {
                    outputStream.close();
                    }
                catch (Exception e) {
                            //
                    }
            }
        }
        }
    public String getIMEIForSlot(int slot) {
        String deviceUniqueIdentifier = null;
        try {
            TelephonyManager tm = (TelephonyManager) mContext.getSystemService(Context.TELEPHONY_SERVICE);
            if (null != tm) {
                try{deviceUniqueIdentifier = tm.getImei(slot);}catch(Exception e){}
            }
            if (null == deviceUniqueIdentifier || 0 == deviceUniqueIdentifier.length()) {
                deviceUniqueIdentifier = "";//Settings.Secure.getString(context.getContentResolver(), Settings.Secure.ANDROID_ID);
            }
        }
        catch(Exception e) {
            }
        return deviceUniqueIdentifier;
    }
public String scanBarcode(byte[] bitmapArray) {
     try {
         Bitmap bitmap = BitmapFactory.decodeByteArray(bitmapArray, 0, bitmapArray.length);

         int[] intArray = new int[bitmap.getWidth()*bitmap.getHeight()];
         bitmap.getPixels(intArray, 0, bitmap.getWidth(), 0, 0, bitmap.getWidth(), bitmap.getHeight());
         RGBLuminanceSource source = new RGBLuminanceSource(bitmap.getWidth(), bitmap.getHeight(),intArray);

         BinaryBitmap bbitmap = new BinaryBitmap(new HybridBinarizer(source));

         Hashtable<DecodeHintType, Object> hints = new Hashtable<DecodeHintType, Object>(5);
         Vector<BarcodeFormat> decodeFormats = new Vector<BarcodeFormat>();
         decodeFormats.add(BarcodeFormat.AZTEC            );
         decodeFormats.add(BarcodeFormat.CODABAR          );
         decodeFormats.add(BarcodeFormat.CODE_128         );
         decodeFormats.add(BarcodeFormat.CODE_39          );
         decodeFormats.add(BarcodeFormat.CODE_93          );
         decodeFormats.add(BarcodeFormat.DATA_MATRIX      );
         decodeFormats.add(BarcodeFormat.EAN_13           );
         decodeFormats.add(BarcodeFormat.EAN_8            );
         decodeFormats.add(BarcodeFormat.ITF              );
         decodeFormats.add(BarcodeFormat.MAXICODE         );
         decodeFormats.add(BarcodeFormat.PDF_417          );
         decodeFormats.add(BarcodeFormat.QR_CODE          );
         decodeFormats.add(BarcodeFormat.RSS_14           );
         decodeFormats.add(BarcodeFormat.RSS_EXPANDED     );
         decodeFormats.add(BarcodeFormat.UPC_A            );
         decodeFormats.add(BarcodeFormat.UPC_E            );
         decodeFormats.add(BarcodeFormat.UPC_EAN_EXTENSION);
         hints.put(DecodeHintType.POSSIBLE_FORMATS, decodeFormats);
         hints.put(DecodeHintType.CHARACTER_SET, "UTF8");
         hints.put(DecodeHintType.ALLOWED_EAN_EXTENSIONS, Boolean.FALSE);
         hints.put(DecodeHintType.PURE_BARCODE, Boolean.FALSE);
         hints.put(DecodeHintType.TRY_HARDER, Boolean.TRUE);
//            Log.d("ZXING", "scanBarcode " + hints.toString());
         MultiFormatReader reader = new MultiFormatReader();
         reader.reset();
         reader.setHints(hints);
         Result res = reader.decode(bbitmap);
//            Result res = new EAN13Reader().decode(bbitmap);
         Log.d("ZXING", "scanBarcode " + res.getBarcodeFormat().toString() + " " + res.getTimestamp() + " " + res.toString());
         return res.getText();
         }
     catch(Exception e) {
         Log.e("ZXING", e.toString());

         return "";
         }
     }

     public float getAccumLevel() {
         Intent batteryIntent = mContext.registerReceiver(null, new IntentFilter(Intent.ACTION_BATTERY_CHANGED));
         int level = batteryIntent.getIntExtra(BatteryManager.EXTRA_LEVEL, -1);
         int scale = batteryIntent.getIntExtra(BatteryManager.EXTRA_SCALE, -1);
         Log.w("ACCUM", "LEVEL: " + level + ", SCALE: " + scale);
         if(level < 0 || scale <= 0 ) {
             return 50.0f;
         }
         return ((float)level / (float)scale) * 100.0f;
     }

    public void showDateTimeConfig() {
        Intent intent = new Intent(android.provider.Settings.ACTION_DATE_SETTINGS);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        mContext.startActivity(intent);
        }
    public void showWifiConfig() {
        Intent intent = new Intent(android.provider.Settings.ACTION_WIFI_SETTINGS);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        mContext.startActivity(intent);
        }
    public void showGsmConfig() {
        Intent intent = new Intent(android.provider.Settings.ACTION_WIRELESS_SETTINGS);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        mContext.startActivity(intent);
        }
    public void showMobileDataConfig() {
        Intent intent = new Intent(android.provider.Settings.ACTION_SETTINGS);
        intent.setClassName("com.android.settings", "com.android.settings.Settings$DataUsageSummaryActivity");
        mContext.startActivity(intent);
        }

    public String currentNetworkInterfaceName() {
            try {

                Enumeration<NetworkInterface> networkInterfaces = NetworkInterface.getNetworkInterfaces();
                while (networkInterfaces.hasMoreElements()) {
                    NetworkInterface thisInterface = networkInterfaces.nextElement();
                    if(!thisInterface.isUp() ||thisInterface.isLoopback() ||thisInterface.isPointToPoint()) continue;
                    return thisInterface.getDisplayName();
                    }
            } catch (Exception e) {
                e.printStackTrace();
            }
            return new String();
        }

    public String sdcardStorage() {
            try {
                File[] list = ContextCompat.getExternalFilesDirs(mContext, null);
                String res = "";
                for(int i = 0; i < list.length; ++i) res +=":::" + list[i].getAbsolutePath();
//               File downlodDir = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS);
//               return downlodDir.getAbsolutePath();
                return res;

            } catch (Exception e) {
                e.printStackTrace();
            }
            return new String();
        }


    public boolean uninstallPackage(String packageName) {
        Log.d("INSTALLER", "Uninstalling package " + packageName);
        Uri packageURI = Uri.parse("package:" +  packageName);
        Intent uninstallIntent = new Intent(Intent.ACTION_DELETE, packageURI);
        mContext.startActivity(uninstallIntent);
        return true;
    }
    public boolean installPackage(String packagePath) {
        Intent promptInstall = new Intent(Intent.ACTION_VIEW);
        promptInstall.setDataAndType(Uri.fromFile(new File(packagePath)),
                                        "application/vnd.android.package-archive");
        promptInstall.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        VmPolicy oldVmPolicy = null;

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            oldVmPolicy = StrictMode.getVmPolicy();
            VmPolicy policy =  new VmPolicy.Builder()
                    .penaltyLog()
                    .build();
            StrictMode.setVmPolicy(policy);
        }
        mContext.startActivity(promptInstall);
        if (oldVmPolicy != null) {
             StrictMode.setVmPolicy(oldVmPolicy);
         }
        return true;
    }
    public void initForeGround(Service service) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            Intent notificationIntent = new Intent(mContext, CbMainActivity.class);
            PendingIntent pendingIntent =
                    PendingIntent.getActivity(mContext, 0, notificationIntent, 0);

            Notification notification =
                      new Notification.Builder(mContext, "87607896ds")
                .setContentTitle("Service started")
                .setContentText("Service started")
    //            .setSmallIcon(R.drawable.icon)
                .setContentIntent(pendingIntent)
                .setTicker("Service started")
                .build();

            // Notification ID cannot be 0.
            service.startForeground(127787, notification);
        }
    }
    public boolean sendAboutToLouncher(String serial, String modelName, int modelCode) {
        try {
            //if(!isPackageInstalled("org.ru.armax_tps570")) return false;
            Intent intent = new Intent();
            intent.addFlags(Intent.FLAG_INCLUDE_STOPPED_PACKAGES);
            intent.setAction("org.ru.armax.ARMAX_PACKAGE_INFO");
            intent.putExtra("cashboxSerial", serial);
            intent.putExtra("cashboxModel", modelCode);
            intent.putExtra("cashboxModelName", modelName);
            intent.putExtra("package", mContext.getPackageName());
            mContext.sendBroadcast(intent);
            Log.d("CASHBOX", serial + " / " + modelName + " / " + modelCode + " / " + mContext.getPackageName());
            return true;
        }
        catch(Exception e) {
            e.printStackTrace();
            return false;
            }
        }

    private boolean isPackageInstalled(String packageName) {
        try {
            PackageManager packageManager = mContext.getPackageManager();
            packageManager.getPackageInfo(packageName, 0);
            return true;
        } catch (PackageManager.NameNotFoundException e) {
            return false;
        }
    }
}
