package ru.armax.cashbox;

import org.qtproject.qt5.android.bindings.QtApplication;
import org.qtproject.qt5.android.bindings.QtActivity;
//import org.apache.commons.codec.binary.Hex;

import android.content.Context;
import android.app.Activity;
import android.nfc.NfcAdapter;
import android.nfc.NfcManager;
import android.nfc.tech.MifareClassic;
import android.nfc.tech.IsoDep;
import android.nfc.Tag;
import android.app.PendingIntent;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.ResolveInfo;
import android.os.Environment;
import android.util.Log;
import android.util.JsonReader;
import android.widget.Toast;
import android.os.Bundle;
import android.os.AsyncTask;
import android.content.BroadcastReceiver;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.graphics.Canvas;
import android.graphics.Rect;
import android.content.pm.PackageInfo;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts.RequestMultiplePermissions;
import androidx.core.app.ActivityCompat;
import androidx.core.content.IntentCompat;

import java.lang.reflect.InvocationTargetException;
import android.widget.Toast;
import java.util.Timer;
import java.util.TimerTask;
import java.util.List;
import java.util.ArrayList;
import java.util.Date;
import java.io.ByteArrayOutputStream;
import android.os.Build;

import android.app.NotificationManager;
import android.app.NotificationChannel;


class BroadcastProcessApi
{
    public static native void processStatusIntent(Object intent);
}

public class CbMainActivity extends QtActivity{
    private static CbMainActivity smInstance = null;
    public static final int REQUEST_ID_MULTIPLE_PERMISSIONS = 1;

    private BroadcastReceiver cashboxStatusReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String intentName = intent.getAction();
            Log.d("QRMAX", "onReceive: " + intentName);
            if(intentName == "ru.armax.cashbox012.status_internal") {
                BroadcastProcessApi.processStatusIntent(intent);
            }

        }
    };

    public CbMainActivity() {
        smInstance = this;

        }
    public void setRestartCode(int code) {
        Log.d("CASHBOX", " ___ " + code);
        if(code == 0x7234FFFF) {
            Intent intent = new Intent(((CbMainActivity)smInstance).getApplicationContext(), CbMainActivity.class);
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
            getApplicationContext().getApplicationContext().startActivity( intent);
            System.exit(0);
            }
        }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d("CASHBOX", "onCreate");
        checkAndRequestPermissions();

        }
    @Override
    public void onDestroy(){
        this.unregisterReceiver(this.cashboxStatusReceiver);
        super.onDestroy();
    }

    @Override
    public void onResume() {
        super.onResume();
        Log.d("CASHBOXJ", "onResume");
        final IntentFilter theFilter = new IntentFilter();
        theFilter.addAction("ru.armax.cashbox012.status_internal");
        this.registerReceiver(cashboxStatusReceiver, theFilter);
    }
    List<String> getNotGrantedPermissions(final String appPackage) {
        List<String> granted = new ArrayList<String>();
        try {
            PackageInfo pi = getPackageManager().getPackageInfo(appPackage, PackageManager.GET_PERMISSIONS);
            for (int i = 0; i < pi.requestedPermissions.length; i++) {
                if ((pi.requestedPermissionsFlags[i] & PackageInfo.REQUESTED_PERMISSION_GRANTED) == 0) {
                    granted.add(pi.requestedPermissions[i]);
                    Log.d("CB.NOT_GRANTED", pi.requestedPermissions[i]);
                }
            }
        } catch (Exception e) {
        }
        return granted;
    }
    @Override
    public void onPause() {
        this.unregisterReceiver(this.cashboxStatusReceiver);
        super.onPause();
    }


    @Override
    public void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
    }



    public void showToast(final String txt, final boolean isLong){

        smInstance.runOnUiThread(new Runnable() {
            public void run() {
                Toast.makeText(smInstance, txt, isLong ? Toast.LENGTH_LONG : Toast.LENGTH_SHORT).show();
          }
        });
//        smLastToastDate = new Date();
    }

    public void startApp(String name) {
        if(name == null || name.isEmpty()) return;
        try {
            Intent intent = getPackageManager().getLaunchIntentForPackage(name);
            startActivity(intent);
            }
        catch (Exception e) {
            }
        }

    public void showMe() {
        Intent intent = new Intent(this, CbMainActivity.class);
        intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP | Intent.FLAG_ACTIVITY_CLEAR_TOP);//otherwise just a white screen
        startActivity(intent);
        }
    private  boolean checkAndRequestPermissions() {
        List<String> perms = getNotGrantedPermissions(getPackageName());
        if (!perms.isEmpty()) {
            ActivityCompat.requestPermissions(this, perms.toArray(new String[perms.size()]), REQUEST_ID_MULTIPLE_PERMISSIONS);
            return false;
        }
        else {
            CashboxService.startCashboxService(this);
            CashboxHttpService.startCashboxHttpService(this);
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
                CharSequence name = "Service Channel ";
                String description = "Service Channel ";
                int importance = NotificationManager.IMPORTANCE_DEFAULT;
                NotificationChannel channel = new NotificationChannel("87607896ds", name, importance);
                channel.setDescription(description);
                // Register the channel with the system; you can't change the importance
                // or other notification behaviors after this
                NotificationManager notificationManager = getSystemService(NotificationManager.class);
                notificationManager.createNotificationChannel(channel);
                }
        }

        return true;
    }
    @Override
    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        Log.d("CASHBOXJ", "Permission callback called-------");
        CashboxService.startCashboxService(this);
        CashboxHttpService.startCashboxHttpService(this);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
              CharSequence name = "Service Channel ";
              String description = "Service Channel ";
              int importance = NotificationManager.IMPORTANCE_DEFAULT;
              NotificationChannel channel = new NotificationChannel("87607896ds", name, importance);
              channel.setDescription(description);
              // Register the channel with the system; you can't change the importance
              // or other notification behaviors after this
              NotificationManager notificationManager = getSystemService(NotificationManager.class);
              notificationManager.createNotificationChannel(channel);
          }

        }

}
