package ru.armax.cashbox.hw;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.os.Environment;
import android.provider.MediaStore;
import android.text.Layout;
import android.text.StaticLayout;
import android.text.TextPaint;
import android.util.Log;
import java.util.Arrays;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.common.BitArray;
import android.graphics.Matrix;
import com.google.zxing.MultiFormatWriter;
import java.nio.ByteBuffer;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.BufferedWriter;
import java.io.OutputStreamWriter;
import java.nio.ByteBuffer;
import java.io.FileOutputStream;
import java.lang.Thread;

import java.text.SimpleDateFormat;
import java.util.Date;

import android.widget.Toast;
import ru.armax.common.AndroidBmpUtil;
import android.os.Handler;
import android.os.Message;

import java.io.FileInputStream;
import java.util.ArrayList;

import com.pos.sdk.printer.PosPrinter;
import com.pos.sdk.printer.PosPrintStateInfo;


enum PrinterState {

    Ok(0), Busy(1), OutOfPaper(2), Overheat(3), TimeOut(4), Malfunction(5), NoInstalledFont(6), BufferOverFlow(7), Unknown(8);

    private int code;

    PrinterState(int code) {
        this.code = code;
    }

    public int getCode() {
        return code;
    }

    public static PrinterState getByCode(int code) {
        switch(code) {
            case 0: return PrinterState.Ok;
            case 1: return PrinterState.OutOfPaper;
            case 2: return PrinterState.Overheat;
            case 3: return PrinterState.Malfunction;
            case 4: return PrinterState.Malfunction;
            default: return PrinterState.Unknown;
            }
        }
}



public class PrinterWrapper extends Object {
    private static final int PRINT_TIMEOUT = 140;
    private static final String[] mStrings = new String[]{"CP437", "CP850", "CP860", "CP863", "CP865", "CP857", "CP737", "CP928", "Windows-1252", "CP866", "CP852", "CP858", "CP874", "Windows-775", "CP855", "CP862", "CP864", "GB18030", "BIG5", "KSC5601", "utf-8"};
    private Context mContext;

    private int mLastErrorCode = 0;

    private PosPrinter mPosPrinter = null;

    private PosPrinter.EventListener mListener = null;
    private String targerStr = "";
    private boolean firstString = true;

    private int lastStringCount = 0;
    private boolean isPortConnected = false;
    private int currentStatus = -1;
    private int currentError = -1;

//    private CountDownLatch mPrintLatch;

    private static final int LF_LEFT        = 0x01000000;
    private static final int LF_RIGHT       = 0x02000000;
    private static final int LF_CENTER      = 0x04000000;
    private static final int LF_BOLD        = 0x08000000;
    private static final int LF_ITALIC      = 0x10000000;
    private static final int LF_INVERT      = 0x20000000;

    public PrinterWrapper(Context context) {
        mContext = context;



        }

    private void createPrinterListener(){
        mListener = new PosPrinter.EventListener() {
            @Override
            public void onInfo(PosPrinter printer, int what, int extra) {
                Log.d("lbpr", "onInfo: what= " + what + ", extra= " + extra);
                //Это я просто наблюдениями за ответами вычислил, если что то разломается, надо будет внимательно еще подебажить
                if (what == 1){
                    currentStatus = extra;
                }

                if (what == PosPrinter.PRINTER_INFO_STATE_CHANGED) {
                    //mHandler.sendMessage(mHandler.obtainMessage(PRINTER_STATE_CHANGED, extra, 0));
                }
            }
            @Override
            public void onError(PosPrinter printer, int what, int extra){
                Log.d("lbpr", "onError: what= " + what + ", extra= " + extra);
                currentError = what;

                switch(what) {
                    case PosPrinter.PRINTER_ERROR_NO_PAPER:
                            //mHandler.sendEmptyMessage(PRINTER_ERROR_NO_PAPER);
                            break;
                    case PosPrinter.PRINTER_ERROR_OVER_HEAT:
                            Log.d("lbpr", "PRINTER_ERROR_OVER_HEAT");
                            //mHandler.sendEmptyMessage(PRINTER_ERROR_OVER_HEAT);
                            break;
                    case PosPrinter.PRINTER_ERROR_STATE:
                        Log.d("lbpr", "PRINTER_ERROR_STATE");
                        if (extra == PosPrinter.PRINTER_STATE_NO_BATTERY) {
                            //mHandler.sendEmptyMessage(PRINTER_ERROR_NO_BATTERY);
                        }
                        break;
                    default:
                        Log.d("lbpr", "PRINTER_ERROR: " + what);
                        break;
                }
            }

            @Override
            public void onCursorChanged(PosPrinter printer, int x, int y, int lastX, int lastY) {
                Log.d("lbpr", "onCursorChanged: x= " + x + ", y= " + ", lastX= " + ", lastY=" + lastY);
            }
        };
        mPosPrinter.setOnEventListener(mListener);
        }

    public boolean startDocument() {
        currentError = -1;
        currentStatus = -1;
        mLastErrorCode = PrinterState.Ok.getCode();
        try {
            mPosPrinter = PosPrinter.open();
            }
        catch(Exception e){
            Log.d("lbpr","objects create exception: "+e.toString());
        }
        if (mPosPrinter != null) {
            try{
                createPrinterListener();
                Log.d("lbpr","All objects created");
            }
            catch(Exception e){
                Log.d("lbpr","objects create exception: "+e.toString());
            }
        }
        else{
            Log.d("lbpr","Cant create printer object");
        }

        return mLastErrorCode == PrinterState.Ok.getCode();
        }

    public boolean finishDocument() {
        mLastErrorCode = PrinterState.Ok.getCode();
        if (mPosPrinter != null) {
                mPosPrinter.setOnEventListener(null);
                mPosPrinter.release();
                mPosPrinter = null;
                mListener = null;
        }
        return mLastErrorCode == PrinterState.Ok.getCode();
        }
    public boolean ifHavePaper() {
        return getStatus() != PrinterState.OutOfPaper.getCode();
        }

    public int getStatus() {
        try {
            startDocument();
            PosPrintStateInfo info = new PosPrintStateInfo();
            mPosPrinter.getPrintStateInfo(info);
            Log.d("lbpr", "STATUS: " + new Integer(info.mState).toString());
            mLastErrorCode =  PrinterState.getByCode(info.mState).getCode();
            finishDocument();
        }
        catch(Exception e) {
            Log.d("lbpr", e.toString());
            mLastErrorCode = PrinterState.Unknown.getCode();
            }
            return mLastErrorCode;
         }
    PrinterState printerState() {
        PrinterState res = PrinterState.Unknown;
        try {
            PosPrintStateInfo info = new PosPrintStateInfo();
            mPosPrinter.getPrintStateInfo(info);
            Log.d("lbpr", "STATUS: " + new Integer(info.mState).toString());
            res = PrinterState.getByCode(info.mState);
        }
        catch(Exception e) {
            Log.d("lbpr", e.toString());
            }
        mLastErrorCode = res.getCode();
        return res;
        }
    private int waitStatus(){
        try{
            long startTime = System.currentTimeMillis();

            while(true){
                long timeDiff = System.currentTimeMillis() - startTime;
                if (currentStatus == 1){
                    Log.d("lbpr","PRNIT_FINISH_DETECTED");
                    return PrinterState.Ok.getCode();
                }
                else
                if (currentError != -1){
                    Log.d("lbpr",String.format("PRNIT_ERROR detected %d", currentError));
                    return PrinterState.getByCode(currentError).getCode();
                }
                else
                if (timeDiff > 60000){
                    Log.d("lbpr",String.format("PRNIT_ERROR printer answer tomeout detected"));
                    return PrinterState.Unknown.getCode();
                }
                Thread.sleep(10);
            }
        }
        catch(Exception e){
            Log.d("lbpr","PRINT_STRING wait status exception: "+e.toString());
            return PrinterState.Unknown.getCode();
        }
    }

    public int lastErrorCode() {
        return mLastErrorCode;
        }
    public int paperWidth() {
        return 384;
        }
    public int imgBlockSize() {
        return 384;
        }
    public boolean feed() {
            return printLine(0, " \n \n \n \n \n \n");
        }

    public void setError(int code) {
        Log.d("PRINT", "setError = " + code);
        mLastErrorCode = code;
        }
    public boolean printLine(int format, String line) {
        try {
            return printTextLine(format, line);
            }
        catch(Exception e) {
            Log.e("PRINT", e.toString());
            return false;
            }
        }
    public boolean printTextLine(int format, String line) {
        if(line == null || line.isEmpty() || line == "") return true;
        Log.w("PRINT", "\n" + line);
        int printGray = format & 0x00001FFF;
        printGray = printGray  / 333;
        if(printGray > 15) printGray = 15;
        else if(printGray < 0) printGray = 0;
        int font      = (format & 0x00006000) >> 13;
        if(font < 1) font = 16;
        else if(font < 2) font = 24;
        else if(font < 3) font = 24;
        else font = 32;
        Log.d("PRINT", new Integer(font).toString());
        int lineSpace = (format & 0x000F8000) >> 15;
        int position =  PosPrinter.Parameters.ALIGH_LEFT;
        if((format & LF_CENTER) == LF_CENTER) position = PosPrinter.Parameters.ALIGH_CENTER;
        else if((format & LF_RIGHT) == LF_RIGHT) position = PosPrinter.Parameters.ALIGH_RIGHT;

        mPosPrinter.cleanCache();
        PosPrinter.Parameters param = mPosPrinter.getParameters();
        param.setFontSize(font);
        param.setPrintAlign(position);
        param.setFontName("/storage/emulated/0/mkassa/UbuntuMono-R.ttf");
        mPosPrinter.setParameters(param);

        String[] splited = line.split("\n");
        for(int i = 0; i < splited.length; ++i) {
             mPosPrinter.addTextToCurCache(splited[i]);//
        }
        long startTime = System.currentTimeMillis();
         mPosPrinter.print();
        Log.w("PRINT", "after print "+ (System.currentTimeMillis() - startTime));
        mLastErrorCode = waitStatus();
        Log.w("PRINT", "after status "+ (System.currentTimeMillis() - startTime));
        return mLastErrorCode == PrinterState.Ok.getCode();
        }


    public boolean printBarCode(String code, int type, int format) {
        Log.w("PRINT", "\n" + code + "\nbarcode " + type);
        int printGray = format & 0x00001FFF;
        printGray = printGray  / 333;
        if(printGray > 15) printGray = 15;
        else if(printGray < 0) printGray = 0;
        int lineSpace = (format & 0x000F8000) >> 15;
        int position =  PosPrinter.Parameters.ALIGH_LEFT;
        if((format & LF_CENTER) == LF_CENTER) position = PosPrinter.Parameters.ALIGH_CENTER;
        else if((format & LF_RIGHT) == LF_RIGHT) position = PosPrinter.Parameters.ALIGH_RIGHT;

        PosPrinter.Parameters param = mPosPrinter.getParameters();
        param.setPrintAlign(position);
        mPosPrinter.setParameters(param);


        Bitmap srcBmp = QRUtil.getBarcodeBmp(code, 384, 160, type);
        Log.w("PRINT", "\n" + srcBmp);
        if(srcBmp == null) {
            setError(-1);
            return false;
            }

//        String qrPath = Environment.getExternalStorageDirectory().toString() + "/mkassa/" + "tmp.bmp";
//        try {
//            File file = new File(qrPath);
//            boolean deleted = file.delete();
//            }
//        catch(Exception e){}

//        AndroidBmpUtil bmpUtil = new AndroidBmpUtil();
//        bmpUtil.save(srcBmp, qrPath);
        mPosPrinter.addBitmapToCache(srcBmp);
        mPosPrinter.print();

        mLastErrorCode = waitStatus();

        return mLastErrorCode == PrinterState.Ok.getCode();

        }

    public boolean printQrCode(String code, int format) {
        Log.w("PRINT", "\n" + code + "\nQR");
        int printGray = format & 0x00001FFF;
        printGray = printGray  / 333;
        if(printGray > 15) printGray = 15;
        else if(printGray < 0) printGray = 0;
        int lineSpace = (format & 0x000F8000) >> 15;
        int position =  PosPrinter.Parameters.ALIGH_LEFT;
        if((format & LF_CENTER) == LF_CENTER) position = PosPrinter.Parameters.ALIGH_CENTER;
        else if((format & LF_RIGHT) == LF_RIGHT) position = PosPrinter.Parameters.ALIGH_RIGHT;

        PosPrinter.Parameters param = mPosPrinter.getParameters();
        param.setPrintAlign(position);
        mPosPrinter.setParameters(param);


        Bitmap srcBmp = QRUtil.createQRCode(code, 280);
        if(srcBmp == null) {
            setError(-1);
            return false;
            }

//        String qrPath = Environment.getExternalStorageDirectory().toString() + "/mkassa/" + "tmp.bmp";
//        try {
//            File file = new File(qrPath);
//            boolean deleted = file.delete();
//            }
//        catch(Exception e){}
//        AndroidBmpUtil bmpUtil = new AndroidBmpUtil();
//        bmpUtil.save(srcBmp, qrPath);
        mPosPrinter.addBitmapToCache(srcBmp);
        mPosPrinter.print();

        mLastErrorCode = waitStatus();

        return mLastErrorCode == PrinterState.Ok.getCode();

        }
    public boolean printBitMap(byte[] bitmapArray, int format) {
        int printGray = format & 0x00001FFF;
        printGray = printGray  / 333;
        if(printGray > 15) printGray = 15;
        else if(printGray < 0) printGray = 0;
        int lineSpace = (format & 0x000F8000) >> 15;
        int position =  PosPrinter.Parameters.ALIGH_LEFT;
        if((format & LF_CENTER) == LF_CENTER) position = PosPrinter.Parameters.ALIGH_CENTER;
        else if((format & LF_RIGHT) == LF_RIGHT) position = PosPrinter.Parameters.ALIGH_RIGHT;
        Log.w("lbpr","\nPRINT_BITMAP_REQUESTED");

        PosPrinter.Parameters param = mPosPrinter.getParameters();
        param.setPrintAlign(position);
        mPosPrinter.setParameters(param);


        Bitmap srcBmp = BitmapFactory.decodeByteArray(bitmapArray, 0, bitmapArray.length);
        if(srcBmp == null) {
            setError(-1);
            return false;
            }

//        String qrPath = Environment.getExternalStorageDirectory().toString() + "/mkassa/" + "tmp.bmp";
//        try {
//            File file = new File(qrPath);
//            boolean deleted = file.delete();
//            }
//        catch(Exception e){}
//        AndroidBmpUtil bmpUtil = new AndroidBmpUtil();
//        bmpUtil.save(srcBmp, qrPath);
//        mPosPrinter.addBmpToCurCache(qrPath);
        mPosPrinter.addBitmapToCache(srcBmp);
        mPosPrinter.print();

        mLastErrorCode = waitStatus();

        return mLastErrorCode == PrinterState.Ok.getCode();

        }
}
