#include "baseqmlapproot.h"
#include "cashboxbuildconfig.h"
#include "androidapihelper.h"

#include <QGuiApplication>
#include <QGuiApplication>
#include <QQmlApplicationEngine>

#include <QtAndroidExtras/QAndroidJniObject>
#include <QtAndroidExtras/QtAndroid>
#include <QAndroidJniEnvironment>
#include <QDebug>

BaseQmlAppRoot *BaseQmlAppRoot::_instance = nullptr;


QQmlApplicationEngine *BaseQmlAppRoot::engine()
{
    return engine_;
}
BaseQmlAppRoot *BaseQmlAppRoot::instance()
{
    return _instance;
}




BaseQmlAppRoot::BaseQmlAppRoot(int &argc, char **argv, const char *applicationName)
    : QObject(nullptr)
    , engine_(nullptr)
{
    _instance = this;
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
    new QGuiApplication(argc, argv);

    qApp->setApplicationName(applicationName);
    qApp->setOrganizationDomain(ORGANISATION_DOMAIN);
    qApp->setOrganizationName(ORGANISATION_NAME);
    qApp->setApplicationVersion(AndroidApiHelper().versionName());
}

BaseQmlAppRoot::~BaseQmlAppRoot()
{
    _instance = nullptr;
}

int BaseQmlAppRoot::exec()
{
    return qApp->exec();
}

bool BaseQmlAppRoot::init(const QString &mainQml)
{
    engine_ = new QQmlApplicationEngine(this);
    const QUrl url(mainQml);
    QEventLoop loop;
    QObject::connect(engine_, &QQmlApplicationEngine::objectCreated,
        qApp, [url, &loop](QObject *obj, const QUrl &objUrl) {
            qWarning() << url << objUrl;
            if (!obj && url == objUrl)
            {

                QCoreApplication::exit(-1);
            }
            else loop.quit();
        }, Qt::QueuedConnection);
    if(!beforeQmlLoading()) return false;
    engine_->load(url);
    loop.exec();
    qWarning() << engine_->rootObjects().isEmpty();
    return !engine_->rootObjects().isEmpty();
}

