#ifndef BASWQMLAPPROOT_H
#define BASWQMLAPPROOT_H

#include <QObject>
#include <QPointer>
#include <QtAndroid>

class QQmlApplicationEngine;
class QThread;

class BaseQmlAppRoot : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(BaseQmlAppRoot)
public:
    static const qint32 RESTART_CODE            = 0x7234FFFF;
    template<typename T>
    static int start(int &argc, char **argv, const char * applicationName, const char *mainQml)
    {
        int res = RESTART_CODE;
//        while(res == RESTART_CODE)
//        {
//            T root(argc, argv, applicationName);
//            if(!root.init(QString::fromUtf8(mainQml))) return -1;
//            res = root.exec();
//            root.release();
//        }
        {
            T root(argc, argv, applicationName);
            if(!root.init(QString::fromUtf8(mainQml))) return -1;
            res = root.exec();
            root.release();
            QtAndroid::androidActivity().callMethod<void>("setRestartCode", "(I)V", res);
        }
        return res;
    }
    QQmlApplicationEngine *engine();

    static BaseQmlAppRoot *instance();

protected:
    static BaseQmlAppRoot *_instance;
    QQmlApplicationEngine *engine_;

    explicit BaseQmlAppRoot(int &argc, char **argv, const char * applicationName);
    virtual ~BaseQmlAppRoot() override;

    virtual int exec();
    virtual bool init(const QString &mainQml);
    virtual void release() = 0;

    virtual bool beforeQmlLoading() = 0;
};


#endif // BASWQMLAPPROOT_H
