#include "basecorehandler.h"

#include "coretransaction.h"
#include "cashboxbuildconfig.h"


#include "logmanip.h"

#include <QDateTime>
#include <QAndroidJniObject>
#include <QtAndroid>
#include <QAndroidJniExceptionCleaner>
#include <QFutureWatcher>
#include <QFuture>
#include <QtConcurrent>


BaseCoreHandler::BaseCoreHandler(QObject *parent)
    : QObject(parent)
    , api_(new UiCashboxServiceApi(this))
    , session_(new SessionWrapper(this))
{

}

BaseCoreHandler::~BaseCoreHandler()
{

}

void BaseCoreHandler::execTask(std::function<QPair<CoreTransaction, CoreApiResult> ()> &task)
{
    QFutureWatcher<QPair<CoreTransaction, CoreApiResult> > *watcher = new QFutureWatcher<QPair<CoreTransaction, CoreApiResult> >();
    connect(watcher, &QFutureWatcher<CoreApiResult>::finished, this, &BaseCoreHandler::taskFinished);
    emit showBusy(true);
    QFuture<QPair<CoreTransaction, CoreApiResult> > future = QtConcurrent::run(task);
    watcher->setFuture(future);

}

void BaseCoreHandler::taskFinished()
{
    QFutureWatcher<QPair<CoreTransaction, CoreApiResult> > *fwatcher = dynamic_cast<QFutureWatcher<QPair<CoreTransaction, CoreApiResult> > *>(sender());
    lmWarning() << sender() << fwatcher;
    QFuture<QPair<CoreTransaction, CoreApiResult> > future = fwatcher->future();
    QPair<CoreTransaction, CoreApiResult>  res = future;
    fwatcher->deleteLater();
    processResult(res.first, res.second);
}

void BaseCoreHandler::toastError(const QString &msg)
{
    emit error(msg);
}
