#ifndef BASECOREHANDLER_H
#define BASECOREHANDLER_H

#include "uicashboxserviceapi.h"
#include "sessionwrapper.h"
#include <QObject>

class BaseCoreHandler : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(BaseCoreHandler)
public:
    explicit BaseCoreHandler(QObject *parent = nullptr);
    ~BaseCoreHandler() override;

signals:
    void showBusy(bool busy);
    void error(QString msg);
protected:
    UiCashboxServiceApi *api_;
    SessionWrapper *session_;

    void execTask(std::function<QPair<CoreTransaction, CoreApiResult> ()> &task);

    virtual void processResult(const CoreTransaction & source, const CoreApiResult &res) = 0;
protected slots:
    void taskFinished();
    void toastError(const QString &msg);
};

#endif // BASECOREHANDLER_H
