#ifndef FISCALIZATIONHANDLER_H
#define FISCALIZATIONHANDLER_H

#include "basecorehandler.h"
//#include "fiscalizationdata.h"

class FiscalizationHandler : public BaseCoreHandler
{
    Q_OBJECT
    QML_ELEMENT
    Q_DISABLE_COPY(FiscalizationHandler)
public:
    explicit FiscalizationHandler(QObject *parent = nullptr);
    ~FiscalizationHandler() override;

    Q_INVOKABLE void writeSerial(const QString &serial);

public slots:
    void fiscalize(const QVariantMap &map);
    void preprint(const QVariantMap &map);
signals:
    void serialWrote();
    void fiscalized();
    void successPreprint();
private:

    void processResult(const CoreTransaction & source, const CoreApiResult &res)override;

private slots:
    void writeCheckedSerial(const QString &serial);
};

#endif // FISCALIZATIONHANDLER_H
