#ifndef LOGINHANDLER_H
#define LOGINHANDLER_H

#include "basecorehandler.h"
#include <QObject>
#include <QNetworkAccessManager>
#include <QNetworkRequest>

class LoginHandler : public BaseCoreHandler
{
    Q_OBJECT
    QML_ELEMENT
    Q_DISABLE_COPY(LoginHandler)
    static const QString LOGIN_PATH;
    Q_PROPERTY(QVariantList cashiersModel READ cashiersModel NOTIFY cashiersModelChanged)
public:
    explicit LoginHandler(QObject *parent = nullptr);
    virtual ~LoginHandler() override;

    Q_INVOKABLE void login(const QString &login, const QString &password);
    QVariantList cashiersModel() const;

signals:
    void loginned();
    void cashiersModelChanged(QVariantList);
private:
    QVariantList cashiersModel_;
    void processResult(const CoreTransaction & source, const CoreApiResult &res)override;
private slots:
    void reloadCashiers();
};

#endif // LOGINHANDLER_H
