#include "receiptconfighandler.h"
#include "cashboxbuildconfig.h"

ReceiptConfigHandler::ReceiptConfigHandler(QObject *parent)
    : BaseCoreConfigHandler{parent}
    , data_(new ReceiptConfigData)
{

}

ReceiptConfigHandler::~ReceiptConfigHandler()
{
    data_.reset();
}

qint64 ReceiptConfigHandler::maxReceiptAmount() const
{
    return data_ ? data_->maxReceiptAmount().value() : 0ll;
}

void ReceiptConfigHandler::setMaxReceiptAmount(qint64 val)
{
    if(data_ && data_->maxReceiptAmount().value() != val)
    {
        data_->setMaxReceiptAmount(FixNumber(DEFAULT_AMOUNT_MULT, val));
        emit maxReceiptAmountChanged();
    }
}

BaseCoreConfigData *ReceiptConfigHandler::object()
{
    return data_.data();
}
