#ifndef RECEIPTCONFIGHANDLER_H
#define RECEIPTCONFIGHANDLER_H

#include "basecoreconfighandler.h"
#include "receiptconfigdata.h"

#include <QtQml>

class ReceiptConfigHandler : public BaseCoreConfigHandler
{
    Q_OBJECT
    Q_DISABLE_COPY(ReceiptConfigHandler)
    QML_ELEMENT

    Q_PROPERTY(qint64 maxReceiptAmount READ maxReceiptAmount WRITE setMaxReceiptAmount NOTIFY maxReceiptAmountChanged)
public:
    explicit ReceiptConfigHandler(QObject *parent = nullptr);
    ~ReceiptConfigHandler() override;

    qint64 maxReceiptAmount() const;
    void setMaxReceiptAmount(qint64 val);
signals:
    void maxReceiptAmountChanged();
private:
    QSharedPointer<ReceiptConfigData> data_;

    BaseCoreConfigData *object() override;
};

#endif // RECEIPTCONFIGHANDLER_H
