#ifndef RECEIPTHANDLER_H
#define RECEIPTHANDLER_H

#include "basecorehandler.h"
#include "runtimeuisettings.h"


#include <receipt.h>

class ReceiptHandler : public BaseCoreHandler
{
    Q_OBJECT
    Q_DISABLE_COPY(ReceiptHandler)
    QML_ELEMENT
    Q_PROPERTY(bool skipPrint READ skipPrint WRITE setSkipPrint NOTIFY skipPrintChanged)
public:
    explicit ReceiptHandler(QObject *parent = nullptr);
    ~ReceiptHandler() override;

    bool skipPrint() const;
    void setSkipPrint(bool newSkipPrint);

public slots:
    void receiptFast(int type, const QVariantMap &data, double cash, double card);
    void correctionFast(int type, const QVariantMap &data, double cash, double card);
    void receipt(int type, const QVariantMap &data, double cash, double card,
                 double prepay, double postpay, double barter);
    void correction(int type, const QVariantMap &data, double cash, double card,
                    double prepay, double postpay, double barter);
signals:
    void success();
    void skipPrintChanged();

private:
    RuntimeUiSettings *uiRuntime_;
    bool skipPrint_;

    void processResult(const CoreTransaction & source, const CoreApiResult &res) override;
};

#endif // RECEIPTHANDLER_H
