#ifndef REPORTSCOREHANDLER_H
#define REPORTSCOREHANDLER_H

#include "basecorehandler.h"

class ReportsCoreHandler : public BaseCoreHandler
{
    Q_OBJECT
    QML_ELEMENT
    Q_DISABLE_COPY(ReportsCoreHandler)
public:
    explicit ReportsCoreHandler(QObject *parent = nullptr);
    ~ReportsCoreHandler() override;


    Q_INVOKABLE QString offlineReportsPath() const;
public slots:
    void openCycle(const QVariantMap &map);
    void openCycleSilent(const QVariantMap &map);
    void closeCycle(const QVariantMap &map, bool brief);
    void closeCycleSilent(const QVariantMap &map, bool brief);
    void calcReport(const QVariantMap &map, bool brief);
    void closeFs(const QVariantMap &map);
    void findDoc(qint32 fd);
    void ofdTicket(qint32 fd);
    void tlvDoc(qint32 fd);
    void regDocFromFs(qint32 num);
    void regTlvDocFromFs(qint32 num);
    void offlineReports();
    void saveOfflineReportToSdCard(const QString &fileName, const QString &baseName);
    void xReport(bool brief = true);
    void fsReport(bool brief = true);
signals:
    void cycleOpened();
    void cycleClosed();
    void calcReportReady();
    void fsClosed();
    void reportIsReady();
    void offlineReportsSaved();
    void xReportSuccess(QString);
private:
    CashboxStatusWrapper *status_;
    void processResult(const CoreTransaction & source, const CoreApiResult &res)override;
};

#endif // REPORTSCOREHANDLER_H
