#ifndef SENDMAILHELPER_H
#define SENDMAILHELPER_H


#include "abstractworkerthread.h"
#include <QObject>
#include <QPointer>
#include <QFileInfo>
#include <QtQml>

class SendMailHelper : public QObject
{
    Q_OBJECT
    QML_ELEMENT
    Q_DISABLE_COPY(SendMailHelper)
public:
    explicit SendMailHelper(QObject *parent = 0);
    ~SendMailHelper() override;

signals:
    void sendResult(bool);
    void progressRegion(int,int);
    void progressValue(int);

public slots:
    void sendMail(bool attachDb, QString comment);
    QString logsSize();
    QString getRedableSize(qint64 size);
    bool clearLogs();

private slots:
    void stopThread();
    void errorMessage(QString message);
    void messageSended();

private:
    QPointer<AbstractWorkerThread> thread_;
    bool processing_;
    QString prepareEmailPassword() const;
    QStringList logFiles();


};

#endif // SENDMAILHELPER_H
