#ifndef SUPPORTMAILER_H
#define SUPPORTMAILER_H

#include "abstractworker.h"

#include <QStringList>

class SupportMailer : public AbstractWorker
{
    Q_OBJECT
public:
    SupportMailer();
    virtual ~SupportMailer();

    QString sender() const;
    void setSender(const QString &sender);

    QString senderFrom() const;
    void setSenderFrom(const QString &senderFrom);

    QString senderName() const;
    void setSenderName(const QString &senderName);

    QStringList recievers() const;
    void setRecievers(const QStringList &recievers);

    QString smtp() const;
    void setSmtp(const QString &smtp);

    quint16 port() const;
    void setPort(const quint16 &port);

    QString user() const;
    void setUser(const QString &user);

    QString password() const;
    void setPassword(const QString &password);

    bool useSssl() const;
    void setUseSssl(bool useSssl);

    bool useAuth() const;
    void setUseAuth(bool useAuth);

    QString subject() const;
    void setSubject(const QString &subject);

    QString text() const;
    void setText(const QString &text);

    QString html() const;
    void setHtml(const QString &html);

    QStringList files() const;
    void setFiles(const QStringList &files);
public slots:
    void send();
signals:
    void progressRegion(int from, int to);
    void progressValue(int val);
    void progressMessage(QString text);
    void errorMessage(QString text);
    void success();
private:
    QString sender_;
    QString senderFrom_;
    QString senderName_;
    QStringList recievers_;
    QString smtp_;
    quint16 port_;
    QString user_;
    QString password_;
    bool useSssl_;
    bool useAuth_;
    QString subject_;
    QString text_;
    QString html_;
    QStringList files_;

    Q_DISABLE_COPY(SupportMailer)


    virtual bool doStart() override;
    virtual bool doStop() override;

    QStringList prepareAttachedFiles();
    void clean();
};

#endif // SUPPORTMAILER_H
