#ifndef CASHIERSMODEL_H
#define CASHIERSMODEL_H

#include "basecatalogmodel.h"

#include "cashier.h"

#include <QtQml>

class CashiersModel : public BaseCatalogModel
{
    Q_OBJECT
    QML_ELEMENT
    Q_DISABLE_COPY(CashiersModel)
public:
    enum CmRoles
    {
        RoleId              = Qt::UserRole + 1,
        RoleServerId        = Qt::UserRole + 2,
        RoleLogin           = Qt::UserRole + 3,
        RoleName            = Qt::UserRole + 4,
        RolePassword        = Qt::UserRole + 5,
        RoleInn             = Qt::UserRole + 6,
        RolePermissions     = Qt::UserRole + 7
    };
    explicit CashiersModel(QObject *parent = nullptr);
    ~CashiersModel() override;

    QHash<int, QByteArray> roleNames() const override;
    QVariant data(const QModelIndex &idx, int role) const override;
    int rowCount(const QModelIndex &parent = QModelIndex()) const override;

    Q_INVOKABLE bool canRemoveCashier(int idx);
public slots:
    void removeCashier(int index);
private:
    ActiveCashiersList cashiers_;

    void doReload() override;
    void processResult(const CoreTransaction & source, const CoreApiResult &res) override;
    QVariantMap prepareItem(int index ) const override;
};



#endif // CASHIERSMODEL_H
