#ifndef HEXSTRINGVALIDATOR_H
#define HEXSTRINGVALIDATOR_H

#include <QValidator>
#include <QtQml>

class HexStringValidator : public QValidator
{
    Q_OBJECT
    Q_DISABLE_COPY(HexStringValidator)
    QML_ELEMENT

    Q_PROPERTY(qint32 maxSize READ maxSize WRITE setMaxSize NOTIFY maxSizeChanged)
    Q_PROPERTY(bool fixedSize READ fixedSize WRITE setFixedSize NOTIFY fixedSizeChanged)
    Q_PROPERTY(bool canBeEmpty READ canBeEmpty WRITE setCanBeEmpty NOTIFY canBeEmptyChanged)

public:
    explicit HexStringValidator(QObject *parent = nullptr);
    ~HexStringValidator() override;

    void fixup(QString & input) const override;
    State validate(QString & input, int & pos) const override;

    qint32 maxSize() const;
    void setMaxSize(qint32 newMaxSize);

    bool fixedSize() const;
    void setFixedSize(bool newFixedSize);

    bool canBeEmpty() const;
    void setCanBeEmpty(bool newCanBeEmpty);

signals:
    void maxSizeChanged();

    void fixedSizeChanged();

    void canBeEmptyChanged();

private:
    qint32 maxSize_;
    bool fixedSize_;
    bool canBeEmpty_;


};

#endif // HEXSTRINGVALIDATOR_H
