#include "innvalidator.h"
#include "logmanip.h"


InnValidator::InnValidator(QObject *parent)
    : QValidator(parent)
{

}

InnValidator::~InnValidator()
{

}

void InnValidator::fixup(QString &input) const
{
     QValidator::fixup(input);
}

QValidator::State InnValidator::validate(QString &input, int &pos) const
{
    Q_UNUSED(pos)
    auto f=[](QString &input) ->QValidator::State {
        if(input.isEmpty()) return Intermediate;
        bool ok = false;
        qint64 v = input.toLongLong(&ok);
        if(!ok) return Invalid;
//NOTE: бывают инн с ведущим нулем, например, бурятия.
        if(QStringLiteral("%1").arg(v, input.size(), 10, QLatin1Char('0')) != input) return Invalid;
        Inn inn(input);
        if(inn.isValid()) return Acceptable;
        else return input.size() == 12 ? Invalid: Intermediate;
        return Intermediate;
    };
    QValidator::State res = f(input);
    return res;
}
