#include "regnumbervalidator.h"
#include "regnumber.h"

RegNumberValidator::RegNumberValidator(QObject *parent)
    : QValidator(parent)
{

}

RegNumberValidator::~RegNumberValidator()
{

}

void RegNumberValidator::fixup(QString &input) const
{
    QValidator::fixup(input);
}

QValidator::State RegNumberValidator::validate(QString &input, int &pos) const
{
    Q_UNUSED(pos)

    if(input.isEmpty()) return Intermediate;
    bool ok = false;
    qint64 r = input.toLongLong(&ok);
    Q_UNUSED(r)
    if(!ok || input.size() > 16) return Invalid;
    if(input.size() < 16) return Intermediate;

    RegNumber rnm(input, serial_, inn_);

    return rnm.isValid() ? Acceptable : Invalid;

}

const QString &RegNumberValidator::inn() const
{
    return inn_;
}

void RegNumberValidator::setInn(const QString &newInn)
{
    if (inn_ == newInn)
        return;
    inn_ = newInn;
    emit innChanged();
}

const QString &RegNumberValidator::serial() const
{
    return serial_;
}

void RegNumberValidator::setSerial(const QString &newSerial)
{
    if (serial_ == newSerial)
        return;
    serial_ = newSerial;
    emit serialChanged();
}
