#ifndef REGNUMBERVALIDATOR_H
#define REGNUMBERVALIDATOR_H

#include <QValidator>
#include <QtQml>

class RegNumberValidator : public QValidator
{
    Q_OBJECT
    QML_ELEMENT
    Q_DISABLE_COPY(RegNumberValidator)
    Q_PROPERTY(QString inn READ inn WRITE setInn NOTIFY innChanged)
    Q_PROPERTY(QString serial READ serial WRITE setSerial NOTIFY serialChanged)

public:
    explicit RegNumberValidator(QObject *parent = nullptr);
    ~RegNumberValidator() override;

    void fixup(QString & input) const override;
    State validate(QString & input, int & pos) const override;
    const QString &inn() const;
    void setInn(const QString &newInn);

    const QString &serial() const;
    void setSerial(const QString &newSerial);

signals:
    void innChanged();
    void serialChanged();

private:
    QString inn_;
    QString serial_;
};

#endif // REGNUMBERVALIDATOR_H
