#ifndef RUNTIMEUISETTINGS_H
#define RUNTIMEUISETTINGS_H

#include "fdfconstants.h"

#include <QObject>
#include <QtQml>
#include <QSettings>

//Тут хранить только самосохраняющиеся настройки. не редактируемые из интерфейса

class RuntimeUiSettings : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(RuntimeUiSettings)
    QML_ELEMENT
    static const QString RUNTIME_SECTION;
public:
    explicit RuntimeUiSettings(QObject *parent = nullptr);
    ~RuntimeUiSettings() override;

    fdf::Tax lastTaxSystem() const;
    void setLastTaxSystem(fdf::Tax tax);

signals:
private:
    QSettings *store_;

    QVariant getValue(const QString &section, const QString &key, const QVariant &defVal = QVariant()) const;
    void setValue(const QString &section, const QString &key, const QVariant &val);
};

#endif // RUNTIMEUISETTINGS_H
