#ifndef SBARCODEFILTER_H
#define SBARCODEFILTER_H


#include "androidapihelper.h"

#include <QAbstractVideoFilter>
#include <QtQml>
#include <QMutex>

class SBarcodeFilter : public QAbstractVideoFilter
{
    Q_OBJECT
    QML_ELEMENT
    Q_DISABLE_COPY(SBarcodeFilter)
    friend class SBarcodeFilterRunnable;
public:
    explicit SBarcodeFilter(QObject *parent = nullptr);
    ~SBarcodeFilter()override;

    QVideoFilterRunnable * createFilterRunnable() override;
signals:
    void barcodeParsed(QString);
private:    
    QString resultCode_;
    QMutex codeMutex_;

    void captureBarcode(const QString &text);
};
//--------------------------------------------------------------------------------------------------
class SBarcodeFilterRunnable: public QVideoFilterRunnable
{
public:
    explicit SBarcodeFilterRunnable(SBarcodeFilter *parent);
    ~SBarcodeFilterRunnable() override;
    QVideoFrame run(QVideoFrame *input,
                    const QVideoSurfaceFormat &surfaceFormat,
                    QVideoFilterRunnable::RunFlags flags) override;
private:
    SBarcodeFilter *parent_;
    AndroidApiHelper *helper_;

private:
    QString parseImage(const QImage &img);
};

#endif // SBARCODEFILTER_H
