#ifndef SERIALCHEKER_H
#define SERIALCHEKER_H

#include "modeldata.h"

#include <QObject>
#include <QNetworkAccessManager>
#include <QNetworkRequest>

class SerialCheker : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(SerialCheker)
    static const QString CHECK_SERIAL_PATH;


public:
    explicit SerialCheker(QObject *parent = nullptr);
    ~SerialCheker() override;
public slots:
    void checkSerial(const QString &serial, const ModelData &model);
signals:
    void serialIsValid(QString);
    void serialChekingError(QString);
private:
    QString serial_;
    QNetworkAccessManager *http_;

private slots:
    void finished(QNetworkReply *reply);
    void sslErrors(QNetworkReply *reply, const QList<QSslError> &errors);
    void onError(const QString &error);
};

#endif // SERIALCHEKER_H
