#ifndef BASECATALOGITEMWRAPPER_H
#define BASECATALOGITEMWRAPPER_H


#include "coretransaction.h"

#include <QObject>
#include <QVariantMap>

class BaseCatalogModel;

class BaseCatalogItemWrapper: public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(BaseCatalogItemWrapper)
public:
    explicit BaseCatalogItemWrapper(QObject *parent = nullptr);
    ~BaseCatalogItemWrapper() override;

    virtual CoreTransaction toSaveTransaction() const = 0;
    virtual QVariantMap toMap() const = 0;
    virtual void parseMap(const QVariantMap &map) = 0;

    Q_INVOKABLE BaseCatalogModel *model() const;
    Q_INVOKABLE void setModel(BaseCatalogModel *model);

signals:
    void showBusy(bool);
    void error(QString);
    void saved();
public slots:
    void setData(const QVariantMap &data);
    void save();
protected:
    BaseCatalogModel *model_;
    virtual void processModel() {}
protected slots:
    void onSavingError(const QString &msg);
    void onItemSaved();

};

#endif // BASECATALOGITEMWRAPPER_H
