#ifndef INCOMINGREGWRAPPER_H
#define INCOMINGREGWRAPPER_H

#include "incomingreg.h"
#include "cashboxstatuswrapper.h"
#include "sessionwrapper.h"
#include <QObject>

class IncomingRegWrapper : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(IncomingRegWrapper)
    QML_ELEMENT
    Q_PROPERTY(QVariantList operationsModel READ operationsModel NOTIFY operationsModelChanged)
    Q_PROPERTY(bool autoMode READ getAutoMode WRITE setAutoMode NOTIFY autoModeChanged)
    Q_PROPERTY(bool offlineMode READ getOfflineMode WRITE setOfflineMode NOTIFY offlineModeChanged)
    Q_PROPERTY(bool encriptionMode READ getEncriptionMode WRITE setEncriptionMode NOTIFY encriptionModeChanged)
    Q_PROPERTY(QString address READ address WRITE setAddress NOTIFY addressChanged)
    Q_PROPERTY(QString ofdInn READ ofdInn WRITE setOfdInn NOTIFY ofdInnChanged)
    Q_PROPERTY(QString userInn READ userInn WRITE setUserInn NOTIFY userInnChanged)
    Q_PROPERTY(QString cashier READ cashier WRITE setCashier NOTIFY cashierChanged)
    Q_PROPERTY(QString boxId READ boxId WRITE setBoxId NOTIFY boxIdChanged)
    Q_PROPERTY(QString regNumber READ regNumber WRITE setRegNumber NOTIFY regNumberChanged)
    Q_PROPERTY(QString ofdName READ ofdName WRITE setOfdName NOTIFY ofdNameChanged)
    Q_PROPERTY(QString userName READ userName WRITE setUserName NOTIFY userNameChanged)
    Q_PROPERTY(QString ftsSite READ ftsSite WRITE setFtsSite NOTIFY ftsSiteChanged)
    Q_PROPERTY(bool allowBasic READ allowBasic WRITE setAllowBasic NOTIFY allowBasicChanged)
    Q_PROPERTY(bool allowSimpleProfit READ allowSimpleProfit WRITE setAllowSimpleProfit NOTIFY allowSimpleProfitChanged)
    Q_PROPERTY(bool allowSimpleProfitExpense READ allowSimpleProfitExpense WRITE setAllowSimpleProfitExpense NOTIFY allowSimpleProfitExpenseChanged)
    Q_PROPERTY(bool allowSingleOnImputedProfit READ allowSingleOnImputedProfit WRITE setAllowSingleOnImputedProfit NOTIFY allowSingleOnImputedProfitChanged)
    Q_PROPERTY(bool allowSingleAgriculturalTax READ allowSingleAgriculturalTax WRITE setAllowSingleAgriculturalTax NOTIFY allowSingleAgriculturalTaxChanged)
    Q_PROPERTY(bool allowPatentSystemOfTaxation READ allowPatentSystemOfTaxation WRITE setAllowPatentSystemOfTaxation NOTIFY allowPatentSystemOfTaxationChanged)
    Q_PROPERTY(QString email READ email WRITE setEmail NOTIFY emailChanged)
    Q_PROPERTY(QString place READ place WRITE setPlace NOTIFY placeChanged)
    Q_PROPERTY(QString cashierInn READ cashierInn WRITE setCashierInn NOTIFY cashierInnChanged)
    Q_PROPERTY(QString additionalParam READ additionalParam WRITE setAdditionalParam NOTIFY additionalParamChanged)
    Q_PROPERTY(QString additionalParamData READ additionalParamData WRITE setAdditionalParamData NOTIFY additionalParamDataChanged)
    Q_PROPERTY(bool allowExternalPrinter   READ getExternalPrinter WRITE setExternalPrinter NOTIFY allowExternalPrinterChanged)
    Q_PROPERTY(bool allowFosaCashbox       READ getFosaCashbox WRITE setFosaCashbox NOTIFY allowFosaCashboxChanged)
    Q_PROPERTY(bool allowInternetOnly      READ getInternetOnly WRITE setInternetOnly NOTIFY allowInternetOnlyChanged)
    Q_PROPERTY(bool allowExcisableProducts READ getExcisableProducts WRITE setExcisableProducts NOTIFY allowExcisableProductsChanged)
    Q_PROPERTY(bool allowLabledProducts    READ getLabledProducts WRITE setLabledProducts NOTIFY allowLabledProductsChanged)
    Q_PROPERTY(bool allowServicesOnly      READ getServicesOnly WRITE setServicesOnly NOTIFY allowServicesOnlyChanged)
    Q_PROPERTY(bool allowGamesCashbox      READ getGamesCashbox WRITE setGamesCashbox NOTIFY allowGamesCashboxChanged)
    Q_PROPERTY(bool allowLotteryCashbox    READ getLotteryCashbox WRITE setLotteryCashbox NOTIFY allowLotteryCashboxChanged)
    Q_PROPERTY(bool allowPawnshop          READ getPawnshop WRITE setPawnshop NOTIFY allowPawnshopChanged)
    Q_PROPERTY(bool allowInsurance         READ getInsurance WRITE setInsurance NOTIFY allowInsuranceChanged)

    Q_PROPERTY(bool allowAutoCashboxForLabled    READ getAutoCashboxForLabled WRITE setAutoCashboxForLabled NOTIFY allowAutoCashboxForLabledCashboxChanged)
    Q_PROPERTY(bool allowRestaurant          READ getRestaurant WRITE setRestaurant NOTIFY allowRestaurantChanged)
    Q_PROPERTY(bool allowWholesale         READ getWholesale WRITE setWholesale NOTIFY allowWholesaleChanged)


    Q_PROPERTY(bool reasonFsChange             READ getFsChange             WRITE setFsChange             NOTIFY reasonFsChangeChanged)
    Q_PROPERTY(bool reasonOfdChange            READ getOfdChange            WRITE setOfdChange            NOTIFY reasonOfdChangeChanged)
    Q_PROPERTY(bool reasonUserNameChange       READ getUserNameChange       WRITE setUserNameChange       NOTIFY reasonUserNameChangeChanged)
    Q_PROPERTY(bool reasonAddressChange        READ getAddressChange        WRITE setAddressChange        NOTIFY reasonAddressChangeChanged)
    Q_PROPERTY(bool reasonOfflineToOnline      READ getOfflineToOnline      WRITE setOfflineToOnline      NOTIFY reasonOfflineToOnlineChanged)
    Q_PROPERTY(bool reasonOnlineToOffline      READ getOnlineToOffline      WRITE setOnlineToOffline      NOTIFY reasonOnlineToOfflineChanged)
    Q_PROPERTY(bool reasonCashboxVersionChange READ getCashboxVersionChange WRITE setCashboxVersionChange NOTIFY reasonCashboxVersionChangeChanged)
    Q_PROPERTY(bool reasonTaxesChange          READ getTaxesChange          WRITE setTaxesChange          NOTIFY reasonTaxesChangeChanged)
    Q_PROPERTY(bool reasonBoxIdChange          READ getBoxIdChange          WRITE setBoxIdChange          NOTIFY reasonBoxIdChangeChanged)
    Q_PROPERTY(bool reasonAutoToSingle         READ getAutoToSingle         WRITE setAutoToSingle         NOTIFY reasonAutoToSingleChanged)
    Q_PROPERTY(bool reasonSingleToAuto         READ getSingleToAuto         WRITE setSingleToAuto         NOTIFY reasonSingleToAutoChanged)
    Q_PROPERTY(bool reasonBasicToFosa          READ getBasicToFosa          WRITE setBasicToFosa          NOTIFY reasonBasicToFosaChanged)
    Q_PROPERTY(bool reasonFosaToBasic          READ getFosaToBasic          WRITE setFosaToBasic          NOTIFY reasonFosaToBasicChanged)
    Q_PROPERTY(bool reasonInternetToBasic      READ getInternetToBasic      WRITE setInternetToBasic      NOTIFY reasonInternetToBasicChanged)
    Q_PROPERTY(bool reasonBasicToInternet      READ getBasicToInternet      WRITE setBasicToInternet      NOTIFY reasonBasicToInternetChanged)
    Q_PROPERTY(bool reasonGamesToBasic         READ getGamesToBasic         WRITE setGamesToBasic         NOTIFY reasonGamesToBasicChanged)
    Q_PROPERTY(bool reasonBasicToGames         READ getBasicToGames         WRITE setBasicToGames         NOTIFY reasonBasicToGamesChanged)
    Q_PROPERTY(bool reasonLotteryToBasic       READ getLotteryToBasic       WRITE setLotteryToBasic       NOTIFY reasonLotteryToBasicChanged)
    Q_PROPERTY(bool reasonBasicToLottery       READ getBasicToLottery       WRITE setBasicToLottery       NOTIFY reasonBasicToLotteryChanged)
    Q_PROPERTY(bool reasonFFDChange            READ getFFDChange            WRITE setFFDChange            NOTIFY reasonFFDChangeChanged)
    Q_PROPERTY(bool reasonAnotherReasons       READ getAnotherReasons       WRITE setAnotherReasons       NOTIFY reasonAnotherReasonsChanged)


public:
    explicit IncomingRegWrapper(QObject *parent = nullptr);
    ~IncomingRegWrapper() override;

    bool getAutoMode()const;
    void setAutoMode(bool set);
    bool getOfflineMode()const;
    void setOfflineMode(bool set);
    bool getEncriptionMode()const;
    void setEncriptionMode(bool set);


    const QString &address() const;
    void setAddress(const QString &newAddress);

    const QString &ofdInn() const;
    void setOfdInn(const QString &newOfdInn);

    const QString &userInn() const;
    void setUserInn(const QString &newUserInn);

    const QString &cashier() const;
    void setCashier(const QString &newCashier);

    const QString &boxId() const;
    void setBoxId(const QString &newBoxId);

    const QString &regNumber() const;
    void setRegNumber(const QString &newRegNumber);

    const QString &ofdName() const;
    void setOfdName(const QString &newOfdName);

    const QString &userName() const;
    void setUserName(const QString &newUserName);

    const QString &ftsSite() const;
    void setFtsSite(const QString &newFtsSite);

    bool allowBasic() const;
    void setAllowBasic(bool set);
    bool allowSimpleProfit() const;
    void setAllowSimpleProfit(bool set);
    bool allowSimpleProfitExpense() const;
    void setAllowSimpleProfitExpense(bool set);
    bool allowSingleOnImputedProfit() const;
    void setAllowSingleOnImputedProfit(bool set);
    bool allowSingleAgriculturalTax() const;
    void setAllowSingleAgriculturalTax(bool set);
    bool allowPatentSystemOfTaxation() const;
    void setAllowPatentSystemOfTaxation(bool set);

    const QString &email() const;
    void setEmail(const QString &newEmail);

    const QString &place() const;
    void setPlace(const QString &newPlace);

    const QString &cashierInn() const;
    void setCashierInn(const QString &newCashierInn);

    const QString &additionalParam() const;
    void setAdditionalParam(const QString &newAdditionalParam);

    QString additionalParamData() const;
    void setAdditionalParamData(const QString &newAdditionalParamData);

    bool getExternalPrinter() const;
    void setExternalPrinter(bool set);
    bool getFosaCashbox() const;
    void setFosaCashbox(bool set);
    bool getInternetOnly() const;
    void setInternetOnly(bool set);
    bool getExcisableProducts() const;
    void setExcisableProducts(bool set);
    bool getLabledProducts() const;
    void setLabledProducts(bool set);
    bool getServicesOnly() const;
    void setServicesOnly(bool set);
    bool getGamesCashbox() const;
    void setGamesCashbox(bool set);
    bool getLotteryCashbox() const;
    void setLotteryCashbox(bool set);
    bool getPawnshop() const;
    void setPawnshop(bool set);
    bool getInsurance() const;
    void setInsurance(bool set);
    bool getAutoCashboxForLabled() const;
    void setAutoCashboxForLabled(bool set);
    bool getRestaurant() const;
    void setRestaurant(bool set);
    bool getWholesale() const;
    void setWholesale(bool set);

    bool getFsChange()const;
    void setFsChange(bool set);
    bool getOfdChange()const;
    void setOfdChange(bool set);
    bool getUserNameChange()const;
    void setUserNameChange(bool set);
    bool getAddressChange()const;
    void setAddressChange(bool set);
    bool getOfflineToOnline()const;
    void setOfflineToOnline(bool set);
    bool getOnlineToOffline()const;
    void setOnlineToOffline(bool set);
    bool getCashboxVersionChange()const;
    void setCashboxVersionChange(bool set);
    bool getTaxesChange()const;
    void setTaxesChange(bool set);
    bool getBoxIdChange()const;
    void setBoxIdChange(bool set);
    bool getAutoToSingle()const;
    void setAutoToSingle(bool set);
    bool getSingleToAuto()const;
    void setSingleToAuto(bool set);
    bool getBasicToFosa()const;
    void setBasicToFosa(bool set);
    bool getFosaToBasic()const;
    void setFosaToBasic(bool set);
    bool getInternetToBasic()const;
    void setInternetToBasic(bool set);
    bool getBasicToInternet()const;
    void setBasicToInternet(bool set);
    bool getGamesToBasic()const;
    void setGamesToBasic(bool set);
    bool getBasicToGames()const;
    void setBasicToGames(bool set);
    bool getLotteryToBasic()const;
    void setLotteryToBasic(bool set);
    bool getBasicToLottery()const;
    void setBasicToLottery(bool set);
    bool getFFDChange()const;
    void setFFDChange(bool set);
    bool getAnotherReasons()const;
    void setAnotherReasons(bool set);

    Q_INVOKABLE QVariantMap getRegData() const;
    QVariantList operationsModel() const;

    Q_INVOKABLE int codeOfOperation(int index) const;


public slots:
    void setRegData(const QVariantMap &data);
    void reset();
    void preprint();
    void fiscalize();
    void genRegNumber();
signals:
    void operationsModelChanged();
    void autoModeChanged();
    void offlineModeChanged();
    void encriptionModeChanged();
    void addressChanged();
    void ofdInnChanged();
    void userInnChanged();
    void cashierChanged();
    void boxIdChanged();
    void regNumberChanged();
    void ofdNameChanged();
    void userNameChanged();
    void ftsSiteChanged();
    void allowBasicChanged();
    void allowSimpleProfitChanged();
    void allowSimpleProfitExpenseChanged();
    void allowSingleOnImputedProfitChanged();
    void allowSingleAgriculturalTaxChanged();
    void allowPatentSystemOfTaxationChanged();
    void emailChanged();
    void placeChanged();
    void cashierInnChanged();
    void additionalParamChanged();
    void additionalParamDataChanged();
    void allowExternalPrinterChanged();
    void allowFosaCashboxChanged();
    void allowInternetOnlyChanged();
    void allowExcisableProductsChanged();
    void allowLabledProductsChanged();
    void allowServicesOnlyChanged();
    void allowGamesCashboxChanged();
    void allowLotteryCashboxChanged();
    void allowPawnshopChanged();
    void allowInsuranceChanged();
    void allowAutoCashboxForLabledCashboxChanged();
    void allowRestaurantChanged();
    void allowWholesaleChanged();

    void reasonFsChangeChanged();
    void reasonOfdChangeChanged();
    void reasonUserNameChangeChanged();
    void reasonAddressChangeChanged();
    void reasonOfflineToOnlineChanged();
    void reasonOnlineToOfflineChanged();
    void reasonCashboxVersionChangeChanged();
    void reasonTaxesChangeChanged();
    void reasonBoxIdChangeChanged();
    void reasonAutoToSingleChanged();
    void reasonSingleToAutoChanged();
    void reasonBasicToFosaChanged();
    void reasonFosaToBasicChanged();
    void reasonInternetToBasicChanged();
    void reasonBasicToInternetChanged();
    void reasonGamesToBasicChanged();
    void reasonBasicToGamesChanged();
    void reasonLotteryToBasicChanged();
    void reasonBasicToLotteryChanged();
    void reasonFFDChangeChanged();
    void reasonAnotherReasonsChanged();
    void readyForPreprint();
    void readyForFiscalize();
    void error(QString);

    void needPreprint(QVariantMap);
    void needFiscalize(QVariantMap);

private:
    IncomingReg currentReg_;
    IncomingReg newReg_;
    CashboxStatusWrapper *status_;
    SessionWrapper *session_;
    QVariantList operationsModel_;

    bool validate();

private slots:
    void onStatusChanged();

};

#endif // INCOMINGREGWRAPPER_H
