#ifndef SESSIONWRAPPER_H
#define SESSIONWRAPPER_H

#include "cashier.h"
#include <QObject>
#include <QPointer>
#include <QMutex>
#include <QtQml>

class SessionWrapper : public QObject
{
    Q_OBJECT
    QML_ELEMENT
    Q_DISABLE_COPY(SessionWrapper)
    friend class LoginHandler;
    Q_PROPERTY(QString cashierName READ cashierName NOTIFY cashierChanged)
public:
    explicit SessionWrapper(QObject *parent = nullptr);
    ~SessionWrapper() override;

    Cashier cashier() const;
    QString cashierName() const;

signals:
    void cashierChanged();
    void cashierNameChanged(QString);
private:
    static QPointer<SessionWrapper> _globalSession;
    static QMutex _sessionMutex;
    static Cashier _cashier;


    explicit SessionWrapper(bool destroyStatic);
    static void setGlobalCashier(const Cashier &cashier);
};

#endif // SESSIONWRAPPER_H
